/** 
 * AbstractAction2: extension de la class action de AbstractAction de Java
 * Les classes Action et AbstractAction  de java permet de centraliser une partie de l'tat d'une fonctionnalit
 * (nom de la commande icone utilisee, tat selectionn ou non) dans un unique objet
 * Par exemple si on a un item de menu et un boutton dans une barre d'outil, ils peuvent tout les deux partager
 * la meme icone et le mme nom. si on appelle la fonction setEnabled sur l'action les deux composants 
 * sont mis a jour
 * Mais elle ne permet pas de centraliser l'etat "Selected" utilis par JCheckBox et JCheckBoxMenuItem 
 * C'est pour cela que les classe Action2 et AbstractAction2 on t crite
 * Ces 2 classe permettent par exemple que lorsqu'on clique sur l'item du menu le boutton dans la barre d'outil s'enfonce
 * galement
 * 
 * @author HEIT Sylvestre & Coustillac Laurent
 * module Action2.java 
 *
 * Programme kartoMNT : cartographie 2D sur cartes numriques
 * Copyright (C) 2002  HEIT Sylvestre & Coustillac Laurent
 * 
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence
 * Publique Gnrale GNU publie par la Free Software Foundation (version 2).
 *
 * Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
 * y compris les garanties de commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
 * Licence Publique Gnrale GNU pour plus de dtails.
 *
 * Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ; si
 * ce n'est pas le cas, crivez  la
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 */
package kartoMNT;

import javax.swing.*;
import java.awt.event.*;



public abstract class AbstractAction2 extends AbstractAction implements Action2
    {
        AbstractAction2()
        {
            super();
            selected=false;
        }
        AbstractAction2(String name)
        {
            super(name);
            selected=false;
        }
        AbstractAction2(String name, Icon icon)
        {
            super(name,icon);
            selected=false;
        }


        public void setSelected(boolean b)
        {
            firePropertyChange("Selected", new Boolean(selected), new Boolean(b));
            selected=b;
        }

        public boolean getSelected()
        {
            return selected;
        }

        protected boolean selected;

    }

