/** 
 * Panel de dialogue permettant de choisir une altitude initiale et un increment pour fixer l'altitude
 * de plusieurs lignes de niveaux  la fois
 *   
 * 
 * @author HEIT Sylvestre & Coustillac Laurent
 *
 *
 * Programme kartoMNT : gnration de MNT  partir d'une carte de lignes de niveaux
 * Copyright (C) 2002  HEIT Sylvestre & Coustillac Laurent
 * 
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence
 *Publique Gnrale GNU publie par la Free Software Foundation (version 2).
 *
 *Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
 *y compris les garanties de commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
 *Licence Publique Gnrale GNU pour plus de dtails.
 *
 *Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ; si
 *ce n'est pas le cas, crivez  la
 *Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 */
package kartoMNT;

import javax.swing.*;
import java.awt.*;
import javax.swing.border.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.awt.image.*;

class AltitudeDialog extends JPanel implements SelectDocumentListener,ActionListener
    {
        AltitudeDialog(DocumentKartoContainer dc,ToolAltitudeMulti t)
        {
            mainWindow=dc;
            toolAltitudeMulti=t;
            jpanel=new JPanel();
            setLayout(new BorderLayout());

            add(jpanel,BorderLayout.WEST);

            gridbag=new GridBagLayout();
            gridBagConstraints = new GridBagConstraints();
            jpanel.setLayout(gridbag);

            gridBagConstraints.fill=GridBagConstraints.NONE;
            gridBagConstraints.anchor =GridBagConstraints.WEST ;
            gridBagConstraints.insets=new Insets(0,0,0,3);

            gridBagConstraints.gridwidth = 1;
            gridBagConstraints.weightx=gridBagConstraints.weighty=0;

            JLabel l1=new JLabel(ResourceManager.get("altInit"));
            gridBagConstraints.gridwidth = 1;
            addc(l1);

            altitude=new JTextField("0");
            altitude.setPreferredSize(new Dimension(50,(int)(altitude.getPreferredSize().getHeight())));

            addc(altitude);

            JLabel l2=new JLabel(ResourceManager.get("incr"));
            gridBagConstraints.gridwidth = 1;
            addc(l2);

            increment=new JTextField("0");
            increment.setPreferredSize(new Dimension(50,(int)(increment.getPreferredSize().getHeight())));
            addc(increment);

            // boutons ok, cancel
            gridBagConstraints.weightx=gridBagConstraints.weighty=0;
            addc(apply=new JButton(ResourceManager.get("apply")));


            apply.addActionListener(this);
        }

        void addc(JComponent comp)
        {
            gridbag.setConstraints(comp, gridBagConstraints);
            jpanel.add(comp);
        }

        public void documentSelected(Document doc)
        {
            documentKarto=(DocumentKarto)doc;
        }

        public void actionPerformed(ActionEvent e)
        {
            if(e.getSource()==apply)
                {
                    if(documentKarto!=null)
                        {
                            Line line=toolAltitudeMulti.getLine();
                            if(line!=null)
                                {
                                    float alt=Float.parseFloat(altitude.getText());
                                    float inc=Float.parseFloat(increment.getText());
                                    documentKarto.getLignesDeNiveaux().setAltitudeOnLine((int)line.getx0(),(int)line.gety0(),(int)line.getx1(),(int)line.gety1(),alt,inc);

                                }
                        }
                }
        }


        protected GridBagLayout gridbag;
        protected GridBagConstraints gridBagConstraints;
        protected JTextField altitude,increment;
        protected JButton apply,cancel;
        protected JPanel jpanel;
        protected DocumentKarto documentKarto;
        protected DocumentKartoContainer mainWindow;
        protected ToolAltitudeMulti toolAltitudeMulti;

    };
