/** 
 *  Barre d'tat:
 *  Elle permet d'afficher un certain nombre d'informations en fonction de la position de la souris sur le document:
 *  les information affiches sont:
 *  les coordonnes courantes
 *  les coordonnes terrain, 
 *  la couleur courante
 *  la couleur selectionnee
 *  l'altitude courante
 *   
 * 
 * @author HEIT Sylvestre & Coustillac Laurent
 *
 *
 * Programme kartoMNT : gnration de MNT  partir d'une carte de lignes de niveaux
 * Copyright (C) 2002  HEIT Sylvestre & Coustillac Laurent
 * 
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence
 *Publique Gnrale GNU publie par la Free Software Foundation (version 2).
 *
 *Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
 *y compris les garanties de commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
 *Licence Publique Gnrale GNU pour plus de dtails.
 *
 *Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ; si
 *ce n'est pas le cas, crivez  la
 *Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 */
package kartoMNT;


import javax.swing .*;
import java.awt.event.*;
import java.awt.Dimension;
import java.awt.*;
import javax.swing.border.*;
import kartoMNT.karto.math.*;
import java.awt.geom.*;
import java.text.*;

/** 
 * Barre d'tat:
 * Affiche les coordonnes courantes, la couleur courante, la couleur selectionne
 */
public class BarreEtat extends JPanel implements SelectDocumentListener,MouseMotionListener/*,ColorListener*/
    {
        BarreEtat(DocumentKartoContainer w)
        {
            JLabel labelesp;
            format=new DecimalFormat("#.#");

            documentKartoContainer=w;
            //documentKartoContainer.addSelectDocumentKartoListener(this);
            currentcanvas=null;
            documentSelected(getCurrentDocument());

            setBorder(new EmptyBorder(2,0,0,0));

            GridBagLayout gridbag;
            setLayout(gridbag=new GridBagLayout());
            GridBagConstraints constraint = new GridBagConstraints();

            labelx=new JLabel("xxxxxx");
            Dimension d=labelx.getPreferredSize();
            labely=new JLabel();
            labelr=new JLabel();
            labelg=new JLabel();
            labelb=new JLabel();

            border=new ReliefBorder(ReliefBorder.LOWERED);
            //border=new BevelBorder(BevelBorder.LOWERED);
            labelr.setBorder(border);
            labelg.setBorder(border);
            labelb.setBorder(border);


            labelespfin=new JLabel();
            labelespfin.setBorder(border);

            labelr.setPreferredSize(new Dimension(70,(int)d.getHeight()));
            labelr.setText(" R=0");
            labelg.setPreferredSize(new Dimension(70,(int)d.getHeight()));
            labelg.setText(" G=0");
            labelb.setPreferredSize(new Dimension(70,(int)d.getHeight()));
            labelb.setText(" B=0");


            constraint.weightx=0;
            constraint.fill=GridBagConstraints.VERTICAL;

            constraint.insets=new Insets(0,0,0,0);
            labelc=new JLabel();
            gridbag.setConstraints(labelc, constraint);
            labelc.setBorder(border);
            labelc.setPreferredSize(new Dimension(150,(int)d.getHeight()) );
            labelc.setText("");
            add(labelc);

            constraint.insets=new Insets(0,2,0,0);
            labelcoordTerrain=new JLabel();
            gridbag.setConstraints(labelcoordTerrain, constraint);
            labelcoordTerrain.setBorder(border);
            labelcoordTerrain.setPreferredSize(new Dimension(250,(int)d.getHeight()) );
            labelcoordTerrain.setText("");
            add(labelcoordTerrain);

            labelesp=createEpace((int)(d.getWidth()/1.5),(int)d.getHeight());
            gridbag.setConstraints(labelesp, constraint);
            add(labelesp);


            JPanel z;
            z=create((int)d.getHeight());
            color=(JPanel)z.getComponent(0);
            color.setBackground(Color.black);
            gridbag.setConstraints(z, constraint);
            add(z);


            gridbag.setConstraints(labelr, constraint);
            add(labelr);
            gridbag.setConstraints(labelg, constraint);
            add(labelg);
            gridbag.setConstraints(labelb, constraint);
            add(labelb);

            // altitude
            labelCurrentAltitude=new JLabel();
            labelCurrentAltitude.setBorder(border);
            labelCurrentAltitude.setPreferredSize(new Dimension(80,(int)d.getHeight()));
            labelCurrentAltitude.setText("");
            gridbag.setConstraints(labelCurrentAltitude, constraint);
            add(labelCurrentAltitude);

            constraint.weightx=1;
            constraint.fill=GridBagConstraints.BOTH;
            gridbag.setConstraints(labelespfin, constraint);
            add(labelespfin);

        }

        public void setMessage(String message)
        {
            labelespfin.setText(message);
        }

        private JPanel create(int d)
        {
            JPanel z=new JPanel();
            z.setLayout(new FlowLayout(FlowLayout.CENTER,0,0));
            JPanel color=new JPanel();


            z.setBorder(border);
            z.setPreferredSize(new Dimension(d,d) );
            Insets insets=border.getBorderInsets(z);
            color.setPreferredSize(new Dimension( d-insets.left-insets.right,
                                                  d-insets.top-insets.bottom ) );
            z.add(color);
            return z;
        }

        private JLabel createEpace(int x,int y)
        {
            JLabel labelesp=new JLabel();
            labelesp.setBorder(border);
            labelesp.setPreferredSize(new Dimension(x,y) );
            return labelesp;
        }


        public void documentSelected(Document doc)
        {
            /*if(currentcanvas!=null)
                currentcanvas.removeMouseMotionListener(this);*/
            if(docKarto!=null)
                {
                    docKarto.layeredPane.removeMouseMotionListener(this);
                    docKarto=null;
                }

            //necessaire car sinon le canvas reste indefiniment en mmoire
            if(doc==null)
                {
                    currentcanvas=null;
                }
            else
                {
                    docKarto=((DocumentKarto)doc);
                    currentcanvas=docKarto.getCarteCanvas();
                    docKarto.layeredPane.addMouseMotionListener(this);
                }
            /*if(currentcanvas!=null)
                currentcanvas.addMouseMotionListener(this);*/
        }


        public void mouseMoved(MouseEvent e)
        {
            DocumentKarto doc=getCurrentDocument();
            if(doc==null)
                return;

            Point coord=new Point();
            double scalex=doc.getCarteCanvas().getScaleX();
            double scaley=doc.getCarteCanvas().getScaleY();
            int x=(int)(e.getX()/scalex);
            int y=(int)(e.getY()/scaley);
            labelc.setText(" x="+x+"  y="+y);

            if(doc.isCalibrated())
                {
                    Proj proj=doc.getProjection();
                    Point2D.Double p=proj.pixels2Lambert(x,y);
                    labelcoordTerrain.setText("X="+format.format(p.x)+"  Y="+format.format(p.y));
                }
            else
                {
                    labelcoordTerrain.setText(ResourceManager.get("noCalib"));
                }

            int c=getCurrentDocument().getCarteCanvas().getRGB(e.getX(),e.getY());
            labelr.setText(" R="+((c& 0x00ff0000)>>16) );
            labelg.setText(" G="+((c& 0x0000ff00)>>8) );
            labelb.setText(" B="+((c& 0x000000ff)) );

            color.setBackground(new Color(c));

            LignesDeNiveaux ldn=getCurrentDocument().getLignesDeNiveaux();
            FloatDataViewer ldnp=getCurrentDocument().getFloatDataViewer();
            if((ldn!=null)&&(ldnp!=null))
                {
                    x=(int)ldnp.canvas2ObjX(e.getX());
                    y=(int)ldnp.canvas2ObjY(e.getY());

                    if((x>=0)&&(x<ldn.getXMax())&&(y>=0)&&(y<ldn.getYMax()))
                        {
                            float altitude=ldn.getValueData(x,y);
                            if( (altitude!=LignesDeNiveaux.LINE_WITH_NO_ALTITUDE)
                                    &&(altitude!=LignesDeNiveaux.EMPTY))
                                {
                                    labelCurrentAltitude.setText(""+altitude+"m");
                                }
                            else
                                {
                                    labelCurrentAltitude.setText(ResourceManager.get("noAlt"));
                                }
                        }
                }

        }

        public void mouseDragged(MouseEvent e)
        {
            mouseMoved(e);
        }


        public void colorSelected(Color c)
        {
            currentColor.setBackground(c);
        }


        public DocumentKarto getCurrentDocument()
        {
            return (documentKartoContainer.getCurrentDocumentKarto());
        }

        JPanel separator()
        {
            JPanel Separator=new JPanel();
            Separator.setBorder(new EmptyBorder(0,0,0,0));
            Separator.setPreferredSize(new Dimension(2,1) );
            return Separator;
        }

        JLabel labelespfin;
        protected DocumentKartoContainer documentKartoContainer;
        protected ImageCanvas currentcanvas;
        JLabel labelc,labelcoordTerrain;
        JLabel labelx,labely,labelr,labelg,labelb,labelrgb;
        JLabel labelCurrentAltitude;

        JPanel rightpanel,leftpanel;
        JPanel color;
        JPanel currentColor;
        Border border;
        DecimalFormat format;
        DocumentKarto docKarto;
    }

