/** 
 * Panel de dialogue permettant de choisir une taille de pinceau et une altitude de trac
 *   
 * 
 * @author HEIT Sylvestre & Coustillac Laurent
 *
 *
 * Programme kartoMNT : gnration de MNT  partir d'une carte de lignes de niveaux
 * Copyright (C) 2002  HEIT Sylvestre & Coustillac Laurent
 * 
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence
 *Publique Gnrale GNU publie par la Free Software Foundation (version 2).
 *
 *Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
 *y compris les garanties de commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
 *Licence Publique Gnrale GNU pour plus de dtails.
 *
 *Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ; si
 *ce n'est pas le cas, crivez  la
 *Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 */
package kartoMNT;


import javax.swing.*;
import java.awt.*;
import javax.swing.border.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.awt.image.*;
import kartoMNT.duck.swing.*;


public class BrushDialog2 extends JPanel implements SelectDocumentListener,ComponentListener
    {
        public BrushDialog2(DocumentKartoContainer frame)
        {
            setLayout(new BorderLayout());

            gridBagLayout=new GridBagLayout();
            setLayout(gridBagLayout);

            gridBagConstraints = new GridBagConstraints();

            gridBagConstraints.fill=GridBagConstraints.NONE;
            gridBagConstraints.anchor =GridBagConstraints.WEST ;

            show=new ShowPinceau();

            show.setDiameter(1);
            show.setMinimumSize(new Dimension(20,20));
            show.setPreferredSize(new Dimension(20,20));
            gridBagConstraints.weightx=0;

            addc(show);


            sizePanel=new JIntInputPanel
                      (ResourceManager.get("taille"),4, show.getDiameter(), 1, 64,
                       JIntInputPanel.DISPOSITION_HORIZONTAL)
                      {
                          public void run()
                          {
                              show.setDiameter(get());

                              if(brush!=null)
                                  brush.setEpaisseur(get());
                          }
                      };
            Dimension dim=sizePanel.getPreferredSize();
            sizePanel.setPreferredSize(new Dimension(dim.width+75,dim.height));

            gridBagConstraints.weightx=0;
            gridBagConstraints.fill= GridBagConstraints.BOTH ;
            addc(sizePanel);

            addc(labelAltitude=new JLabel(ResourceManager.get("currAlt")));

            altitude=new JTextField("0");
            altitude.setPreferredSize(new Dimension(80,(int)(altitude.getPreferredSize().getHeight())));
            gridBagConstraints.weightx=0;
            gridBagConstraints.fill= GridBagConstraints.NONE ;

            addc(altitude);

            gridBagConstraints.gridwidth = GridBagConstraints.REMAINDER ;
            gridBagConstraints.weightx=1;
            addc(new JPanel());

            listener=new MyListener();
            altitude.addActionListener(listener);
            altitude.getDocument().addDocumentListener(listener);
            addComponentListener(this);

        }


        void addc(JComponent comp)
        {
            gridBagLayout.setConstraints(comp, gridBagConstraints);
            add(comp);
        }




        protected boolean isAltitude(float f)
        {
            return ((brush.altitude!=LignesDeNiveaux.LINE_WITH_NO_ALTITUDE) &&(brush.altitude!=LignesDeNiveaux.EMPTY));
        }

        public void setBrush(Brush b)
        {
            brush=b;
            int epaisseur=brush.epaisseur;
            show.setDiameter(epaisseur);
            sizePanel.set(epaisseur);

            altitude.setText(Float.toString(brush.altitude));


        }

        public void documentSelected(Document doc)
        {
            documentKarto=(DocumentKarto)doc;

        }


        class ShowPinceau extends JPanel
            {
                ShowPinceau()
                {
                    super();
                    D=1;
                    setBackground(new Color(255,255,255,255));
                    pinceau=new Color(0,0,0,255);
                    setOpaque(true);
                }

                public void paint(Graphics gr)
                {
                    Dimension dim=getSize();
                    Graphics2D g=(Graphics2D)gr;
                    g.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON ) ;

                    g.clearRect(0,0,dim.width,dim.height);
                    g.setColor(pinceau);
                    g.fillOval((dim.width-D)/2,(dim.height-D)/2, D,D);
                }

                public void setDiameter(int d)
                {
                    D=d;
                    repaint();
                }
                public int getDiameter()
                {
                    return D;
                }

                protected int D;
                protected Color pinceau;
            }

        public void componentHidden(ComponentEvent e)
        {
            if(documentKarto!=null)
                {
                    documentKarto.getFloatDataViewer().setSpecialColor(2,LignesDeNiveaux.TEMP);
                }
        }

        public void componentMoved(ComponentEvent e)
        {}

        public void componentResized(ComponentEvent e)
        {}

        public void componentShown(ComponentEvent e)
        {
            listener.go();
        }

        class MyListener implements ActionListener,DocumentListener
            {
                public void actionPerformed(ActionEvent e)
                {
                    go();
                }


                public void changedUpdate(DocumentEvent e)
                {
                    go();
                }
                public void insertUpdate(DocumentEvent e)
                {
                    go();
                }
                public void removeUpdate(DocumentEvent e)
                {
                    go();
                }



                protected void go()
                {

                    try
                        {
                            brush.altitude=Float.parseFloat(altitude.getText());
                            if(documentKarto!=null)
                                {
                                    documentKarto.getFloatDataViewer().setSpecialColor(2,brush.altitude);
                                }
                        }
                    catch (NumberFormatException e)
                    {}

                }

            }
        ;

        protected JIntInputPanel sizePanel;

        protected JTextField altitude;
        protected JLabel labelAltitude;
        protected GridBagLayout gridBagLayout;
        protected GridBagConstraints gridBagConstraints;
        protected ShowPinceau show;
        protected DocumentKarto documentKarto;
        protected Brush brush;
        protected MyListener listener;
    }
