/** 
 * ButtonBorder: bordure de bouton
 *   
 * 
 * @author HEIT Sylvestre & Coustillac Laurent
 *
 *
 * Programme kartoMNT : gnration de MNT  partir d'une carte de lignes de niveaux
 * Copyright (C) 2002  HEIT Sylvestre & Coustillac Laurent
 * 
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence
 *Publique Gnrale GNU publie par la Free Software Foundation (version 2).
 *
 *Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
 *y compris les garanties de commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
 *Licence Publique Gnrale GNU pour plus de dtails.
 *
 *Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ; si
 *ce n'est pas le cas, crivez  la
 *Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 */

package kartoMNT;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;


class ButtonBorder extends AbstractBorder
    {

        public static final int RAISED=1;
        public static final int LOWERED=2;

        public static final double mul=1.2;   //clair

        public static final double mul2=0.66; //sombre

        public ButtonBorder(int typ)
        {
            type=typ;
            def=true;

        }




        public ButtonBorder(int typ,Color c)
        {
            type=typ;
            c1=new Color(Math.min((int)(c.getRed()  *mul),255),
                         Math.min((int)(c.getGreen()*mul),255),
                         Math.min((int)(c.getBlue() *mul),255) );
            c2=new Color((int)(c.getRed()*mul2),(int)(c.getGreen()*mul2),(int)(c.getBlue()*mul2));
            color=c;
            def=false;
        }

        public ButtonBorder(int typ,int r,int g,int b)
        {
            type=typ;
            c1=new Color(Math.min((int)(r*mul),255),
                         Math.min((int)(g*mul),255),
                         Math.min((int)(b*mul),255)
                        );
            c2=new Color((int)(r*mul2),(int)(g*mul2),(int)(b*mul2));
            def=false;
        }

        public Insets getBorderInsets(Component c)
        {
            if(type==RAISED)
                return new Insets(1,1,2,2);
            else
                return new Insets(2,2,1,1);
        }

        public boolean isBorderOpaque()
        {
            return true;
        }

        private void calculColors(Component comp)
        {
            Color c=comp.getBackground();
            c1=new Color(Math.min((int)(c.getRed()  *mul),255),
                         Math.min((int)(c.getGreen()*mul),255),
                         Math.min((int)(c.getBlue() *mul),255) );
            c2=new Color((int)(c.getRed()*mul2),(int)(c.getGreen()*mul2),(int)(c.getBlue()*mul2));
            color=c;
        }


        public void paintBorder(Component c, Graphics g, int x, int y, int dx, int dy)
        {
            if(def)
                calculColors(c);

            if(type==RAISED)
            {}
            else
                {
                    g.setColor(c1);
                }
            g.drawLine(x+dx-1,y+dy-1, x+dx-1,y);
            g.drawLine(x+dx-1,y+dy-1, x,y+dy-1);

            if(type==RAISED)
                {
                    g.setColor(c1);
                }
            else
                {
                    g.setColor(c2);
                }
            g.drawLine(x,y, x+dx-1,y);
            g.drawLine(x,y, x,y+dy-1);


            if(type==RAISED)
                {
                    g.setColor(c2);
                    g.drawLine(x+dx-2,y+dy-2, x+dx-2,y+1);
                    g.drawLine(x+dx-2,y+dy-2, x+1,y+dy-2);

                    g.setColor(c1);
                    g.drawLine(x,y, x+dx-1,y);
                    g.drawLine(x,y, x,y+dy-1);

                    g.setColor(Color.black);
                    g.drawLine(x+dx-1,y+dy-1, x+dx-1,y);
                    g.drawLine(x+dx-1,y+dy-1, x,y+dy-1);
                }

            if(type==LOWERED)
                {
                    g.setColor(c1);
                    g.drawLine(x+dx-1,y+dy-1, x+dx-1,y);
                    g.drawLine(x+dx-1,y+dy-1, x,y+dy-1);

                    g.setColor(c2);
                    g.drawLine(x+1,y+1, x+dx-2,y+1);
                    g.drawLine(x+1,y+1, x+1,y+dy-2);

                    g.setColor(Color.black);
                    g.drawLine(x,y, x+dx-1,y);
                    g.drawLine(x,y, x,y+dy-1);
                }
        }


        private Dimension dim;
        protected Color c1,c2,color;
        protected boolean def;
        protected int type;
    }

