/** 
 * Panel de dialogue permettant d'entrer les coordonnes terrain d'un point de calibration
 *   
 * 
 * @author HEIT Sylvestre & Coustillac Laurent
 *
 *
 * Programme kartoMNT : gnration de MNT  partir d'une carte de lignes de niveaux
 * Copyright (C) 2002  HEIT Sylvestre & Coustillac Laurent
 * 
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence
 *Publique Gnrale GNU publie par la Free Software Foundation (version 2).
 *
 *Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
 *y compris les garanties de commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
 *Licence Publique Gnrale GNU pour plus de dtails.
 *
 *Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ; si
 *ce n'est pas le cas, crivez  la
 *Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 */
package kartoMNT;


import javax.swing.*;
import java.awt.*;
import javax.swing.border.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.awt.image.*;

import kartoMNT.karto.outils.*;

class CalibrationDialog extends DocumentPanel implements SelectDocumentListener,ActionListener,
			PointCalibrationSelectListener
{
	CalibrationDialog(DocumentKartoContainer dc)
	{
		mainWindow=dc;

		jpanel=new JPanel();
		setLayout(new BorderLayout());
		add(jpanel,BorderLayout.WEST);

		gridbag=new GridBagLayout();
		gridBagConstraints = new GridBagConstraints();
		jpanel.setLayout(gridbag);

		gridBagConstraints.fill=GridBagConstraints.NONE;
		gridBagConstraints.anchor =GridBagConstraints.WEST ;
		gridBagConstraints.insets=new Insets(0,0,0,2);

		gridBagConstraints.gridwidth = 1;
		gridBagConstraints.weightx=gridBagConstraints.weighty=0;


		JLabel l1=new JLabel(ResourceManager.get("calibPoints")+" x=");
		gridBagConstraints.gridwidth = 1;
		addc(l1);

		xcarte=new JTextField("0");
		xcarte.setPreferredSize(new Dimension(50,(int)(xcarte.getPreferredSize().getHeight())));

		addc(xcarte);

		JLabel l2=new JLabel("y=");
		gridBagConstraints.gridwidth = 1;
		addc(l2);

		ycarte=new JTextField("0");
		ycarte.setPreferredSize(new Dimension(50,(int)(ycarte.getPreferredSize().getHeight())));

		addc(ycarte);

		// bouton ok
		gridBagConstraints.weightx=gridBagConstraints.weighty=0;
		addc(apply=new JButton("Ok"));

		gridBagConstraints.insets=new Insets(0,20,0,0);
		addc(buttonCalibrer=new JButton(ResourceManager.get("calibCarte")));

		documentSelected(dc.getCurrentDocumentKarto());

		apply.addActionListener(this);
		buttonCalibrer.addActionListener(this);

		apply.setEnabled(false);

	}

	void addc(JComponent comp)
	{
		gridbag.setConstraints(comp, gridBagConstraints);
		jpanel.add(comp);
	}

	public void documentSelected(Document doc)
	{
		documentKarto=(DocumentKarto)doc;

		if(pointCalibrationSet!=null)
			{
				pointCalibrationSet.removeSelectListener(this);
				calibrationPoint=null;
			}
		if(documentKarto!=null)
			{
				pointCalibrationSet=documentKarto.getPointCalibrationSet();
				pointCalibrationSelected(pointCalibrationSet.getSelected());
				pointCalibrationSet.addSelectListener(this);
			}
		buttonCalibrer.setEnabled(documentKarto!=null);

	}

	public void pointCalibrationSelected(PointCalibrationModel p)
	{
		calibrationPoint=p;
		apply.setEnabled(p!=null);

		if(p!=null)
			{
				xcarte.setText(""+p.getX());
				ycarte.setText(""+p.getY());
			}
	}

	public void actionPerformed(ActionEvent e)
	{
		if(e.getSource()==apply)
			{
				if(calibrationPoint!=null)
					{
						try
							{

								double x=Double.parseDouble(xcarte.getText());
								double y=Double.parseDouble(ycarte.getText());
								calibrationPoint.setCoords(x,y);

							}
						catch(NumberFormatException ex)
							{
								MsgInfo msg=new MsgInfo(frame,MsgInfo.ERROR,MsgInfo.OK,ResourceManager.get("fillError"));
							}
						// action
					}
			}

		if(e.getSource()==buttonCalibrer)
			{
				if(documentKarto!=null)
					documentKarto.calibrer();
				else{
					MsgInfo msg=new MsgInfo(frame,MsgInfo.INFO,MsgInfo.OK,ResourceManager.get("EnregCarteAvCalib"));
				}
			}

	}


	protected GridBagLayout gridbag;
	protected GridBagConstraints gridBagConstraints;
	protected JTextField xcarte,ycarte;
	protected JButton apply;
	protected JButton buttonCalibrer;
	protected JPanel jpanel;
	protected DocumentKarto documentKarto;
	protected DocumentKartoContainer mainWindow;
	protected PointCalibrationSet pointCalibrationSet;
	protected PointCalibrationModel calibrationPoint;

};
