/** 
 * CalquesDialog
 * Panel de dialogue permettant de dcider si un calque est affich ou non et de rgler la transparence
 *   
 * 
 * @author HEIT Sylvestre & Coustillac Laurent
 *
 *
 * Programme kartoMNT : gnration de MNT  partir d'une carte de lignes de niveaux
 * Copyright (C) 2002  HEIT Sylvestre & Coustillac Laurent
 * 
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence
 *Publique Gnrale GNU publie par la Free Software Foundation (version 2).
 *
 *Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
 *y compris les garanties de commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
 *Licence Publique Gnrale GNU pour plus de dtails.
 *
 *Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ; si
 *ce n'est pas le cas, crivez  la
 *Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 */
package kartoMNT;


import javax.swing.*;
import java.awt.*;
import javax.swing.border.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.awt.image.*;
import kartoMNT.duck.swing.*;


public class CalquesDialog extends DocumentPanel implements ListCellRenderer,SelectDocumentListener,
            ListSelectionListener
    {

        public CalquesDialog(DocumentKartoContainer frame)
        {


            itemLabel=new JLabel();


            jpanel=this;

            constraint = new GridBagConstraints();
            jpanel.setLayout(new BorderLayout());

            constraint.anchor =GridBagConstraints.CENTER;
            constraint.insets=new Insets(2,2,2,2);

            calques=new JList();
            calques.setCellRenderer(this);
            icone1=new ImageIcon("icones/notvisible.gif");
            icone2=new ImageIcon("icones/visible.gif");

            MouseListener mouseListener = new MouseAdapter()
                                          {
                                              public void mouseClicked(MouseEvent e)
                                              {
                                                  int index = calques.locationToIndex(e.getPoint());
                                                  Rectangle r=calques.getCellBounds(index, index);

                                                  if ((e.getClickCount() == 2) || (e.getX()-r.x <icone1.getIconWidth()))
                                                      {

                                                          if(documentKarto!=null)
                                                              {
                                                                  ProprietesCalque p=documentKarto.getProprietesCalque(index);

                                                                  documentKarto.setCalqueVisible(p.numero,!documentKarto.isCalqueVisible(p.numero));
                                                                  calques.repaint();
                                                              }
                                                      }
                                              }
                                          };

            calques.addMouseListener(mouseListener);
            calques.addListSelectionListener(this);
            calques.setBorder(new EmptyBorder(0,0,0,0));

            JScrollPane scrollPane = new JScrollPane(calques);
            scrollPane.setPreferredSize(new Dimension(110,100));

            constraint.gridwidth = GridBagConstraints.REMAINDER;
            constraint.fill = GridBagConstraints.BOTH;
            jpanel.add(scrollPane,BorderLayout.CENTER);


            documentKarto=null;

            final CalquesDialog _this=this;

            alpha=new JIntInputPanel
                  ("Opacite=",4, 255, 0, 255,
                   JIntInputPanel.DISPOSITION_HORIZONTAL)
                  {
                      public void run()
                      {
                          if(cd.documentKarto!=null)
                              {
                                  int index=calques.getSelectedIndex();
                                  if(index>=0)
                                      {
                                          ProprietesCalque p=documentKarto.getProprietesCalque(index);
                                          documentKarto.setAlpha(p.numero,((double)get())/255.0);
                                      }
                              }
                      }
                      public CalquesDialog cd=_this;
                  };

            jpanel.add(alpha,BorderLayout.SOUTH);

        }


        public void valueChanged(ListSelectionEvent e)
        {
            int i=calques.getSelectedIndex();



            if( (documentKarto!=null)&&(i!=-1) )
                {
                    ProprietesCalque p=documentKarto.getProprietesCalque(i);
                    alpha.setEnabled(true);
                    alpha.set((int)(documentKarto.getAlpha(p.numero)*255));
                }
            else
                {
                    alpha.setEnabled(false);
                }

        }





        public Component getListCellRendererComponent(
            JList list,
            Object value,            // value to display
            int index,               // cell index
            boolean isSelected,      // is the cell selected
            boolean cellHasFocus)    // the list and the cell have the focus
        {
            if (isSelected)
                {
                    itemLabel.setBackground(list.getSelectionBackground());
                    itemLabel.setForeground(list.getSelectionForeground());
                }
            else
                {
                    itemLabel.setBackground(list.getBackground());
                    itemLabel.setForeground(list.getForeground());

                }
            itemLabel.setEnabled(list.isEnabled());
            itemLabel.setFont(list.getFont());
            itemLabel.setOpaque(true);

            itemLabel.setIcon(icone1);
            if(documentKarto==null)
                {
                    itemLabel.setText("???");
                    return itemLabel;
                }
            ProprietesCalque p=documentKarto.getProprietesCalque(index);
            if(p==null)
                {
                    itemLabel.setText("???");
                    return itemLabel;
                }

            itemLabel.setText(p.nom);

            if(p.visible)
                itemLabel.setIcon(icone2);

            return itemLabel;
        }


        private void updatefromDoc()
    {}


        public void documentSelected(Document doc)
        {
            documentKarto=(DocumentKarto)doc;
            if(doc!=null)
                calques.setListData(new String[documentKarto.getNbNamedCalques()]);
            else
                calques.setListData(new String[0]);
        }

        protected JList calques;
        private GridBagConstraints constraint;
        private GridBagLayout gridbag;
        private JPanel jpanel;
        private ImageIcon icone1,icone2;
        private JLabel itemLabel;
        protected DocumentKarto documentKarto;
        JIntInputPanel alpha;
    }
