/** 
 * Interface implementee par les objets qui contiennent plusieurs documents Karto
 * Interface implmente par MainWindowSDI (Single Document Interface) et 
 * MainWindowMDI (Multiple Document Interface)
 * cette interface permet de faire en sorte que le programme fonctionne avec les deux types d'interfaces
 * 
 * @author HEIT Sylvestre & Coustillac Laurent
 *
 *
 * Programme kartoMNT : gnration de MNT  partir d'une carte de lignes de niveaux
 * Copyright (C) 2002  HEIT Sylvestre & Coustillac Laurent
 * 
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence
 *Publique Gnrale GNU publie par la Free Software Foundation (version 2).
 *
 *Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
 *y compris les garanties de commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
 *Licence Publique Gnrale GNU pour plus de dtails.
 *
 *Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ; si
 *ce n'est pas le cas, crivez  la
 *Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 */
package kartoMNT;


interface DocumentKartoContainer extends DocumentContainer
    {
        // ajoute un listener
        public void addSelectDocumentKartoListener(SelectDocumentListener l);
        // enleve un listener
        public void removeSelectDocumentKartoListener(SelectDocumentListener l);

        // fonction qui doit tre appele par un DocumentKarto lorsqu'il est selectionn
        // (apelle dans la fonction DocumentKarto.selected)
        public void notifySelectDocumentKartoListener(DocumentKarto doc);

        // obtient le container suivant qui doit tre utilis lorsqu'on ajoute un nouveau document
        // cela peut sembler un peut bizarre mais cela permet d'unifier les deux types d'interface
        public DocumentKartoContainer nextDocumentKartoContainer();
        // obtient le document courant
        public DocumentKarto getCurrentDocumentKarto();
    };



