/** 
 * Object permettant de grer le Drag & Drop d'un fichier de l'explorateur windows vers un composant
 * Cet classe n'a pas t encore t test sur d'autres plateformes que windows
 *
 * Elle est utilis pour faire glisser un fichier contenant une image ou un document karto dans la fentre de l'application
 * 
 *
 * @author HEIT Sylvestre & Coustillac Laurent
 *
 *
 * Programme kartoMNT : gnration de MNT  partir d'une carte de lignes de niveaux
 * Copyright (C) 2002  HEIT Sylvestre & Coustillac Laurent
 * 
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence
 *Publique Gnrale GNU publie par la Free Software Foundation (version 2).
 *
 *Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
 *y compris les garanties de commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
 *Licence Publique Gnrale GNU pour plus de dtails.
 *
 *Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ; si
 *ce n'est pas le cas, crivez  la
 *Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 */
package kartoMNT;

import java.awt.*;
import java.io.*;
import java.util.*;
import java.awt.event.*;
import java.awt.dnd.*;
import java.awt.datatransfer.*;
import javax.swing.*;
import javax.swing.event.*;

/**
  * permet de detecter si un fichier a t dplac vers le composant (drag and drop)
  * La mthode fileDropped est appele  chaque fois qu'un fichier
  * est dpos dans le composant spcifi
  */

abstract public class DropFileManager implements DropTargetListener
    {

        public DropFileManager(Component c)
        {
            new DropTarget (c, this);
        }

        public DropFileManager()
        {}


        public void addComponent(Component c)
        {
            new DropTarget (c, this);
        }

        abstract void fileDropped(File file);

        public void dragEnter (DropTargetDragEvent dropTargetDragEvent)
        {
            dropTargetDragEvent.acceptDrag (DnDConstants.ACTION_COPY_OR_MOVE);
        }

        public void dragExit (DropTargetEvent dropTargetEvent)
        {}

        public void dragOver (DropTargetDragEvent dropTargetDragEvent)
        {}

        public void dropActionChanged (DropTargetDragEvent dropTargetDragEvent)
        {}

        public synchronized void drop (DropTargetDropEvent dropTargetDropEvent)
        {
            try
                {
                    Transferable tr = dropTargetDropEvent.getTransferable();
                    if (tr.isDataFlavorSupported (DataFlavor.javaFileListFlavor))
                        {
                            dropTargetDropEvent.acceptDrop (DnDConstants.ACTION_COPY_OR_MOVE);
                            java.util.List fileList = (java.util.List)
                                                      tr.getTransferData(DataFlavor.javaFileListFlavor);
                            Iterator iterator = fileList.iterator();
                            while (iterator.hasNext())
                                {
                                    File file = (File)iterator.next();

                                    fileDropped(file);
                                }
                            dropTargetDropEvent.getDropTargetContext().dropComplete(true);
                        }
                    else
                        {
                            System.err.println(ResourceManager.get("dragAndDropError"));
                            dropTargetDropEvent.rejectDrop();
                        }
                }
            catch (IOException io)
                {
                    io.printStackTrace();
                    dropTargetDropEvent.rejectDrop();
                }
            catch (UnsupportedFlavorException ufe)
                {
                    ufe.printStackTrace();
                    dropTargetDropEvent.rejectDrop();
                }
        }

        protected DropTarget dropTarget;
    }

