/** 
 * JToggleButton2: extension de la class action de JToggleButton
 * Mme chose que JToggleButton sauf qu'on utilise la classe Action2 au lieu de la classe action
 * Cela permet  plusieurs boutons ou items de partager le mme tat "Selected"
 * On peut faire en sorte que lorsqu'on clique sur un item du menu (JCheckBoxMenuItem2)
 * le boutton dans la barre d'outil (JToggleButton2) s'enfonce galement (s'ils partagent la mme Action2)
 * 
 * 
 * @author HEIT Sylvestre & Coustillac Laurent
 * module Action2.java 
 *
 * Programme kartoMNT : cartographie 2D sur cartes numriques
 * Copyright (C) 2002  HEIT Sylvestre & Coustillac Laurent
 * 
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence
 *Publique Gnrale GNU publie par la Free Software Foundation (version 2).
 *
 *Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
 *y compris les garanties de commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
 *Licence Publique Gnrale GNU pour plus de dtails.
 *
 *Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ; si
 *ce n'est pas le cas, crivez  la
 *Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 */
package kartoMNT;

import javax.swing.AbstractAction;
import javax.swing.*;
import java.awt.event.*;
import java.beans.*;




public class JToggleButton2 extends JToggleButton implements ItemListener
    {
        JToggleButton2(Action2 a)
        {
            super(a);
            addItemListener(this);
        }


        public void itemStateChanged(ItemEvent e)
        {
            ((Action2)getAction()).setSelected(isSelected());
        }

        protected PropertyChangeListener createActionPropertyChangeListener(Action a)
        {
            PropertyChangeListener pl=super.createActionPropertyChangeListener(a);
            return new MyPropertyChangeListener(pl,this);
        }

        protected void configurePropertiesFromAction(Action a)
        {
            super.configurePropertiesFromAction(a);
            setSelected( ((Action2)a).getSelected() );
        }

    }

