/** 
 * Calque permettant d'afficher une ligne (ou une flche)
 *
 * @author HEIT Sylvestre & Coustillac Laurent
 *
 *
 * Programme kartoMNT : gnration de MNT  partir d'une carte de lignes de niveaux
 * Copyright (C) 2002  HEIT Sylvestre & Coustillac Laurent
 * 
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence
 *Publique Gnrale GNU publie par la Free Software Foundation (version 2).
 *
 *Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
 *y compris les garanties de commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
 *Licence Publique Gnrale GNU pour plus de dtails.
 *
 *Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ; si
 *ce n'est pas le cas, crivez  la
 *Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 */
package kartoMNT;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
Objet ligne 
*/
class Line extends GraphicObject
    {

        Line(double x0,double y0,double x1,double y1)
        {
            super();
            init();
            calcparam(x0,y0,x1,y1);
            updateReferential();
        }

        Line()
        {
            super();
            init();
            calcparam(0,0,0,0);
            updateReferential();

        }

        void init()
        {
            setOpaque(false);
            calcparam(0,0,0,0);
            Color color=new Color(0,0,0);
            /*addMouseListener(this);
            addMouseMotionListener(this);*/

            selected=-1;
            lfleche0=0.0;
            lfleche1=0.0;
        }

        public void setColor(Color c)
        {
            color=c;
        }

        public void setExtremiteFleche(int extr,double lfleche)
        {
            if(extr==0)
                {
                    lfleche0=lfleche;
                    f0x=.5;
                    f0y=.7;
                    double d=Math.sqrt(f0x*f0x+f0y*f0y);
                    f0x=f0x*lfleche/d;
                    f0y=f0y*lfleche/d;
                }
            if(extr==1)
                {
                    lfleche1=lfleche;
                    f1x=.5;
                    f1y=.7;
                    double d=Math.sqrt(f1x*f1x+f1y*f1y);
                    f1x=f1x*lfleche/d;
                    f1y=f1y*lfleche/d;

                }
        }

        protected void calcparam(double x0,double y0,double x1,double y1)
        {
            lastx0=x0;
            lasty0=y0;
            lastx1=x1;
            lasty1=y1;
            posx=Math.min(x0,x1);
            posy=Math.min(y0,y1);
            int lfleche=(int)Math.max(lfleche0,lfleche1)+1;
            center_dx=lfleche;
            center_dy=lfleche;
            /*double cdx=canvas2ObjX(center_dx);
            double cdy=canvas2ObjY(center_dy);*/

            linex0=x0-posx;//+cdx;
            liney0=y0-posy;//+cdy;
            linex1=x1-posx;//+cdx;
            liney1=y1-posy;//+cdy;
            double dx=( Math.max(x0,x1)-posx )*getScaleX();
            double dy=( Math.max(y0,y1)-posy )*getScaleY();
            setSize(new Dimension((int)dx+2*lfleche+1,(int)dy+1+2*lfleche));
        }

        // repere: referential
        public void draw(double x0,double y0,double x1,double y1)
        {
            calcparam(x0,y0,x1,y1);
            updateReferential();

        }

        // repere: image
        public void drawPanelCoords(int x0,int y0,int x1,int y1)
        {
            calcparam(x0/getScaleX(),y0/getScaleY(),x1/getScaleX(),y1/getScaleY());
            updateReferential();
        }

        public void paint(Graphics g)
        {
            g.setColor(color);
            int lx0=(int)obj2CanvasX(linex0);//+center_dx;
            int  lx1=(int)obj2CanvasX(linex1);//+center_dx;
            int ly0=(int)obj2CanvasY(liney0);//+center_dy;
            int ly1=(int)obj2CanvasY(liney1);//+center_dy;

            g.drawLine(lx0,ly0,lx1,ly1);

            double vx=linex0-linex1;
            double vy=liney0-liney1;

            if(  ((lfleche0!=0)||(lfleche1!=0)) && ((vx!=0) || (vy!=0))  )
                {
                    double d=Math.sqrt(vx*vx+vy*vy);
                    vx/=d;
                    vy/=d;
                    double vx2;
                    double vy2;
                    if(lfleche1!=0)
                        {
                            vx2=vy*f1x+vx*f1y;
                            vy2=-vx*f1x+vy*f1y;

                            g.drawLine(lx1,ly1,lx1+(int)vx2,ly1+(int)vy2);
                        }
                    if(lfleche0!=0)
                        {
                            vx2=vy*f0x+vx*f0y;
                            vy2=-vx*f0x+vy*f0y;
                            g.drawLine(lx0,ly0,lx0-(int)vx2,ly0-(int)vy2);
                        }

                    if(lfleche1!=0)
                        {
                            vx2=-vy*f1x+vx*f1y;
                            vy2=+vx*f1x+vy*f1y;
                            g.drawLine( lx1,ly1, lx1+(int)vx2, ly1+(int)vy2);
                        }
                    if(lfleche0!=0)
                        {
                            vx2=-vy*f0x+vx*f0y;
                            vy2=+vx*f0x+vy*f0y;
                            g.drawLine( lx0, ly0, lx0-(int)vx2, ly0-(int)vy2);
                        }

                }
        }

        void setAlpha(double a)
        {//alpha=a;
        }

        public void updateReferential()
        {

            int dx=(int)(getScaleX()*(Math.max(linex0,linex1))+2*center_dx+1);
            int dy=(int)(getScaleY()*(Math.max(liney0,liney1))+2*center_dy+1);
            setSize(new Dimension(dx,dy));
            super.updateReferential();
        }

        private boolean inside(int x1,int y1,int x2,int y2)
        {
            return (Math.pow(x1-x2,2)+Math.pow(y1-y2,2))<16;
        }

        public void mouseClicked(MouseEvent e)
        {

            if( inside(e.getX(), e.getY(), (int)obj2CanvasX(linex0), (int)obj2CanvasY(liney0)) )
                {
                    selected=1;
                }
            else if( inside(e.getX(), e.getY(),  (int)obj2CanvasX(linex1), (int)obj2CanvasY(liney1)) )
                {
                    selected=2;
                }
        }

        public void mouseEntered(MouseEvent e)
        {}

        public void mouseExited(MouseEvent e)
        {}

        public void mousePressed(MouseEvent e)
        {}

        public void mouseReleased(MouseEvent e)
        {
            selected=-1;
        }


        public void mouseMoved(MouseEvent e)
        {}


        public void mouseDragged(MouseEvent e)
        {
            if(selected==1)
                {
                    draw(canvas2ObjX(e.getX())+posx,canvas2ObjY(e.getY())+posy, posx+linex1,posy+liney1);
                }
            else if(selected==2)
                {
                    draw( posx+linex0, posy+liney0, canvas2ObjX(e.getX())+posx, canvas2ObjY(e.getY())+posy);
                }

        }

        double getx0()
        {
            return posx+linex0;
        }
        double gety0()
        {
            return posy+liney0;
        }
        double getx1()
        {
            return posx+linex1;
        }
        double gety1()
        {
            return posy+liney1;
        }

        double linex0,liney0,linex1,liney1;
        protected Color color;
        protected int selected;

        double lastx0,lasty0,lastx1,lasty1;
        double lfleche0,lfleche1;
        double f0x,f0y,f1x,f1y;
    }


