package kartoMNT;

import java.util.Hashtable;
import java.net.*;
import java.io.*;

/**
 * Chargeur de classe  partir du code binaire ".class" d'une classe
 * Cette classe permet de recharger dynamiquement une classe prcompile <BR>
 * D'apres le livre Programmation reseau avec Java  edition O'Reilly.
 */
public class MNTClassLoader {
	
	
	public static MNTClassInterface loadUrl(String URLName,String packName) {
		String s;
		URL u;
		try {
			u = new URL(URLName);
			s = u.getFile();
		}
		catch (Exception e) {
			System.out.println("Mauvaise URL("+URLName+":" + e);
			return null;
		}
		/** classe decrivant le script */
		java.lang.Class kartoClass;
		/** instance du script */
		MNTClassInterface kartoClassInstance = null;
		try {
			String nomSlachPackClass=s;
			if (nomSlachPackClass.lastIndexOf(".class")>0)
				nomSlachPackClass=nomSlachPackClass.substring(0,nomSlachPackClass.lastIndexOf(".class"));
			else {
				System.out.println("Erreur : '"+s+"' ne se termine pas par '.class'");
				return null;
			}
			//System.out.println("1");
			//String nomPack1Class= nomSlachPackClass.replace('/','.');
			//System.out.println("2");
			//String nomPackClass= nomPack1Class.replace('\\','.');
			//System.out.println("3");
			URLScriptClassLoader urlScriptClassLoader = new URLScriptClassLoader(u);
			
			kartoClass=urlScriptClassLoader.loadClass(packName+"."+nomSlachPackClass.substring(nomSlachPackClass.lastIndexOf('/')+1));
			
		}
		catch (Exception e) {
			System.out.println("URL introuvable("+URLName+":" + e);
			return null;
		}
		if (kartoClass ==null){
			System.out.println("URL introuvable("+URLName+")");
			return null;
		}
		try {
			
			kartoClassInstance = (MNTClassInterface) kartoClass.newInstance();
		}
		catch(ClassCastException e) {
			// pas de MNTClassInterface definie ? erreur ...
			System.out.println("L'URL ("+URLName+") ne drive par de MNTClassInterface :" + e);
			return null;
		}
		catch(Exception e){
			// Erreur plus generique ...
			System.out.println("Impossible de charger :" +URLName);
			return null;
		}
		return kartoClassInstance;
	}

    


}// Fin de la classe
