/** Fenetre principale du logiciel (Multiple Document Interface)
 *  La classe MainWindowMDI ne contient pas les dernire fonctionnalits du logiciel
 * car elle n'a pas t mise a jour
 * Voir plutot MainWindowSDI qui est a jour et contient les dernires fontionnalits
 *
 * @author HEIT Sylvestre & Coustillac Laurent
 *
 *
 * Programme kartoMNT : gnration de MNT  partir d'une carte de lignes de niveaux
 * Copyright (C) 2002  HEIT Sylvestre & Coustillac Laurent
 * 
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence
 *Publique Gnrale GNU publie par la Free Software Foundation (version 2).
 *
 *Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
 *y compris les garanties de commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
 *Licence Publique Gnrale GNU pour plus de dtails.
 *
 *Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ; si
 *ce n'est pas le cas, crivez  la
 *Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 */
package kartoMNT;


import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import com.sun.image.codec.jpeg.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.beans.*;
import java.awt.Toolkit;
import javax.swing.plaf.ColorUIResource;




class JScrollDesktopPane extends JPanel implements ChangeListener,AdjustmentListener
    {

        void init()
        {
            setLayout(new BorderLayout(0,0));
            jviewport=new JViewport();

            Rectangle r=jDesktopPane.getBounds();
            Dimension d=jviewport.getSize();
            vScrollBar=new JScrollBar(JScrollBar.VERTICAL,
                                      0,
                                      d.height,
                                      0,
                                      r.y+r.height);
            hScrollBar=new JScrollBar(JScrollBar.HORIZONTAL,
                                      0,
                                      d.width,
                                      0,
                                      r.x+r.width);

            add(jviewport,BorderLayout.CENTER);
            jviewport.setView(jDesktopPane);

            //if(d.height>r.y+r.height)
            add(vScrollBar,BorderLayout.EAST);

            //if(d.width>r.x+r.width)

            JPanel p=new JPanel();
            GridBagLayout gridbag;
            p.setLayout(gridbag=new GridBagLayout());
            GridBagConstraints constraint = new GridBagConstraints();
            add(p,BorderLayout.SOUTH);

            constraint.weightx=1;
            constraint.fill=GridBagConstraints.BOTH;
            gridbag.setConstraints(hScrollBar, constraint);
            p.add(hScrollBar);
            p2=new JPanel();
            constraint.weightx=0;
            constraint.fill=GridBagConstraints.BOTH;
            gridbag.setConstraints(p2, constraint);
            p.add(p2);

            Dimension dim=vScrollBar.getPreferredSize();
            Dimension dim2=hScrollBar.getPreferredSize();
            p2.setPreferredSize(new Dimension((int)dim.getWidth(),(int)dim2.getHeight()));

            hScrollBar.addAdjustmentListener(this);
            vScrollBar.addAdjustmentListener(this);

            jviewport.addChangeListener(this);
        }

        JScrollDesktopPane(JDesktopPane view)
        {
            super();
            jDesktopPane=view;
            oldx=oldy=0;
            init();
        }


        protected void updateDim()
        {
            if(jDesktopPane==null)
                return;
            Component c;

            if(jDesktopPane.getComponentCount()==0)
                {
                    maxx=0;
                    maxy=0;
                    minx=0;
                    miny=0;
                }
            else
                {
                    c=jDesktopPane.getComponent(0);
                    maxx=c.getX()+c.getWidth();
                    maxy=c.getY()+c.getHeight();
                    minx=c.getX();
                    miny=c.getY();
                }
            for(int i=1;i<jDesktopPane.getComponentCount();i++)
                {
                    c=jDesktopPane.getComponent(i);
                    maxx=Math.max(c.getX()+c.getWidth(),maxx);
                    maxy=Math.max(c.getY()+c.getHeight(),maxy);
                    minx=Math.min(c.getX(),minx);
                    miny=Math.min(c.getY(),miny);

                }
            needupdate=false;

        }


        void move2(int dx,int dy)
        {

            JInternalFrame[] ifs=jDesktopPane.getAllFrames();
            for(int i=0;i<ifs.length;i++)
                {
                    ifs[i].setLocation(ifs[i].getX()+dx,ifs[i].getY()+dy);
                }
        }



        void updateScroll()
        {
            updateDim();

            int jy=jviewport.getHeight();
            int jx=jviewport.getWidth();
            int y1=Math.min(miny,0);
            int y2=Math.max(maxy,jy);
            int x1=Math.min(minx,0);
            int x2=Math.max(maxx,jx);


            if((jx>=x2-x1)&&hScrollBar.isVisible())
                {
                    hScrollBar.setVisible(false);
                    p2.setVisible(false);
                }
            if((jx<x2-x1)&& (!hScrollBar.isVisible()))
                {
                    hScrollBar.setVisible(true);
                }

            if((jy>=y2-y1)&&vScrollBar.isVisible())
                {
                    vScrollBar.setVisible(false);
                    p2.setVisible(false);
                }
            if((jy<y2-y1)&& (!vScrollBar.isVisible()))
                {
                    vScrollBar.setVisible(true);
                }
            if((jx<x2-x1)&&(jy<y2-y1)&& (!p2.isVisible()))
                {
                    p2.setVisible(true);
                }

            vScrollBar.setValues(oldy,jy,oldy+y1,oldy+y2);
            hScrollBar.setValues(oldx,jx,oldx+x1,oldx+x2);
            validate();
            repaint();

        }


        public void adjustmentValueChanged(AdjustmentEvent e)
        {
            if(e.getAdjustmentType()==AdjustmentEvent.TRACK)
                {
                    posx=hScrollBar.getValue();
                    posy=vScrollBar.getValue();
                    if((oldx!=posx) || (oldy!=posy))
                        {
                            move2(oldx-posx,oldy-posy);
                            oldx=posx;
                            oldy=posy;
                            minx+=oldx-posx;
                            maxx+=oldx-posx;
                            miny+=oldx-posx;
                            maxy+=oldx-posx;
                        }

                }

        }


        public void stateChanged(ChangeEvent e)
        {
            oldx=hScrollBar.getValue();
            oldy=vScrollBar.getValue();
            updateScroll();
        }



        JViewport getViewport()
        {
            return jviewport;
        }



        protected JDesktopPane jDesktopPane;
        JViewport jviewport;
        JScrollBar vScrollBar,hScrollBar;
        int oldx,posx,oldy,posy;
        int maxx,maxy,minx,miny;
        boolean needupdate;
        JPanel p2;
        int z;
    }











class MyButton extends JButton implements MouseListener
    {
        MyButton(Icon _icon)
        {
            super(_icon);
            icon=_icon;
            Dimension dim=new Dimension(0,0);
            raised=new ButtonBorder(ButtonBorder.RAISED);
            lowered=new ButtonBorder(ButtonBorder.LOWERED);
            setBorder(raised);
            addMouseListener(this);
        }

        public void mouseClicked(MouseEvent e)
        {}

        public void mouseEntered(MouseEvent e)
        {}
        public void mouseExited(MouseEvent e)
        {
            setBorder(raised);
            repaint();
        }

        public void mousePressed(MouseEvent e)
        {
            setBorder(lowered);
            repaint();
        }

        public void mouseReleased(MouseEvent e)
        {
            setBorder(raised);
            repaint();
        }

        public Dimension getPreferredSize()
        {
            insets=getBorder().getBorderInsets(this);
            return new Dimension( (int)(insets.left+insets.right)+icon.getIconWidth(), (int)(insets.top+insets.bottom)+icon.getIconHeight() );
        }

        public void paint(Graphics g)
        {
            dim=getSize();
            g.setColor(getBackground()) ;
            g.fillRect(0,0, dim.width, dim.height);
            if(getBorder()!=null)
                {
                    insets=getBorder().getBorderInsets(this);

                    if(dim!=null)
                        getBorder().paintBorder(this,g,0,0, (int)(dim.getWidth()),((int)dim.getHeight()));
                    icon.paintIcon(this,g,insets.left,insets.top);
                }
            else
                icon.paintIcon(this,g,0,0);
        }

        protected Icon icon;
        private Insets insets;
        private Dimension dim;

        private ButtonBorder raised,lowered;
    }












class MainWindowMDI extends JFrame implements WindowListener,ActionListener,DocumentKartoContainer
            ,DocumentMNTContainer
    {

        public MainWindowMDI()
        {
            super("KartoMNT");
            title="KartoMNT";
            documentListener=new Vector();
            actionList = new Hashtable();
            createInterface();
            notifyNoDocument();
        }




        private int getTitleBarHeight(JInternalFrame intf)
        {
            Point p1=intf.getLocationOnScreen();
            Point p2=intf.getContentPane().getLocationOnScreen();
            return p2.y-p1.y;
        }



        public void addDocument(Component doc,String name)
        {
            JInternalFrame internalframe=new JInternalFrame(name);
            internalframe.setResizable(true);
            internalframe.setMaximizable(true);
            internalframe.setIconifiable(true);
            internalframe.setClosable(true);

            internalframe.setFrameIcon(new ImageIcon("icones/kartoicon.gif"));

            JScrollPane scroll=new JScrollPane();
            scroll.setViewportView(doc);
            internalframe.getContentPane().add(scroll);
            //internalframe.getContentPane().add(doc);

            jDesktopPane.add(internalframe);

            if(maximizedFrame!=null)
                restaurer();
            internalframe.show();
            positionneFrameCascade(internalframe);

            /*if(maximizedFrame!=null)
                {restaurer();

                internalframe.show();
                positionneFrameCascade(internalframe);
                maximizeFrame(internalframe);
                }
            else 
                {internalframe.show();
                positionneFrameCascade(internalframe);}
            */

            /*if(maximizedFrame!=null)
                {maximizeFrame(internalframe);
                }
            else
                {//jDesktopPane.add(internalframe);
                internalframe.show();
                }

            if(maximizedComponent!=null)
                {mainPanel.remove(maximizedComponent);
                 mainPanel.add(scrollpane,BorderLayout.CENTER);
                 
                internalframe.show();         
                 //positionneFrameCascade(internalframe);

                 mainPanel.remove(scrollpane);
                 mainPanel.add(maximizedComponent,BorderLayout.CENTER);
                }
             else
                {
                 positionneFrameCascade(internalframe);
                }*/

        }


        public void addDocument(Component doc)
        {
            addDocument(doc,new String(""));
        }


        public void addDocument(Document doc)
        {
            addDocument((Component)doc);
            doc.selected();

        }

        public void addDocument(Document doc,String name)
        {
            addDocument((Component)doc,name);
            doc.selected();
        }


        public Rectangle getViewportRect()
        {
            return scrollpane.getViewport().getViewRect();
        }


        public void closeFrame(JInternalFrame frame)
        {
            try
                {
                    frame.setIcon(false);
                }
            catch(PropertyVetoException ve)
            {}

            /*DocumentKarto doc=(DocumentKarto)frame.getContentPane().getComponent(0);
            doc._DocumentKarto();  // necessaire pour liberer la memoire*/

            boolean max=false;
            if(frame==maximizedFrame)
                {
                    restaurer();
                    max=true;
                }
            JInternalFrame ifrbak=jDesktopPane.getSelectedFrame();
            jDesktopPane.remove(frame);

            JInternalFrame ifr=null;

            ifr=jDesktopPane.getSelectedFrame();
            if((ifr==null) || (ifr==ifrbak))
                {
                    JInternalFrame[] ifs=jDesktopPane.getAllFrames();
                    int layer,maxlayer;

                    maxlayer=0;
                    if(ifs.length<=0)
                        {
                            //notifySelectDocumentKartoListener(null);
                            notifyNoDocument();
                            return;
                        }
                    for(int i=0;i<ifs.length;i++)
                        {
                            layer=ifs.length-1-jDesktopPane.getIndexOf(ifs[i]);
                            if(layer>=maxlayer)
                                {
                                    maxlayer=layer;
                                    ifr=ifs[i];
                                }
                        }
                    jDesktopPane.setSelectedFrame(ifr);

                }

            ((Document)ifr.getContentPane().getComponent(0)).selected();

            if(max)
                {
                    maximizeFrame(ifr);
                }

        }


        public void maximizeFrame(JInternalFrame f)
        {
            // s'il y a dja un composant maximis, on l'enlve
            if(maximizedFrame!=null)
                {
                    mainPanel.remove(maximizedComponent);
                    maximizedFrame.getContentPane().add(maximizedComponent);
                    jDesktopPane.add(maximizedComponent);
                    try
                        {
                            maximizedFrame.setMaximum(false);
                        }
                    catch(PropertyVetoException ve)
                    {}
                }
            else
                {//getContentPane().remove(scrollpane);
                    mainPanel.remove(scrollpane);
                }
            maximizedFrame=f;

            maximizedComponent=f.getContentPane().getComponent(0);
            f.getContentPane().remove(maximizedComponent);
            mainPanel.add(maximizedComponent,BorderLayout.CENTER);
            menuPanel.add(menuBouttonPanel);

            if(f.getTitle()!=null)
                if(!f.getTitle().equals(""))
                    setTitle(title+" ("+f.getTitle()+")");

            validate();
            repaint();
        }

        public void restaurer()
        {
            if(maximizedComponent!=null)
                {
                    mainPanel.remove(maximizedComponent);
                    maximizedFrame.getContentPane().add(maximizedComponent);
                    maximizedComponent=null;
                    try
                        {
                            maximizedFrame.setMaximum(false);
                        }
                    catch(PropertyVetoException ve)
                    {}
                    maximizedFrame=null;
                }
            ///if(getContentPane()!=scrollpane)
            {//getContentPane().add(scrollpane,BorderLayout.CENTER);
                mainPanel.add(scrollpane,BorderLayout.CENTER);
                menuPanel.remove(menuBouttonPanel);
            }
            setTitle(title);
            validate();
            repaint();

        }

        public void iconify(JInternalFrame fr)
        {
            if(fr==maximizedFrame)
                {
                    mainPanel.remove(maximizedComponent);
                    maximizedFrame.getContentPane().add(maximizedComponent);
                    mainPanel.add(scrollpane,BorderLayout.CENTER);
                    menuPanel.remove(menuBouttonPanel);
                    maximizedFrame=null;
                    maximizedComponent=null;
                }

            try
                {
                    fr.setIcon(true);
                }
            catch(PropertyVetoException ve)
            {}
            setTitle(title);
            validate();
            repaint();

        }



        private void positionneFrameCascade(JInternalFrame ifr)
        {
            int sx,sy,sx1,sy1;
            Rectangle r=scrollpane.getViewport().getViewRect();
            sx1=(int)(3.0/4.0*r.getWidth());
            sy1=(int)(3.0/4.0*r.getHeight());

            int delta=getTitleBarHeight(ifr);
            int mod=((int)r.getHeight()-sy1)/delta+1;
            JInternalFrame[] ifs=jDesktopPane.getAllFrames();

            int layer=ifs.length-1-jDesktopPane.getIndexOf(ifr);

            sx=Math.max(sx1,delta);
            sy=Math.max(sy1,delta);

            ifr.setLocation((layer%mod)*delta,(layer%mod)*delta);
            ifr.setSize(sx,sy);
        }


        // reorganise les fenetres en cascade
        public void cascade()
        {
            Rectangle r;
            Dimension d;
            int sx,sy,sx1,sy1;
            int layer;

            restaurer();
            r=scrollpane.getViewport().getViewRect();


            JInternalFrame[] ifs=jDesktopPane.getAllFrames();
            if(ifs.length<=0)
                return;
            sx1=(int)(3.0/4.0*r.getWidth());
            sy1=(int)(3.0/4.0*r.getHeight());
            int delta=getTitleBarHeight(ifs[0]);
            int mod=((int)r.getHeight()-sy1)/delta+1;
            for(int i=0;i<ifs.length;i++)
                {
                    layer=ifs.length-1-jDesktopPane.getIndexOf(ifs[i]);
                    //ifs[i].setSize(0,0);

                    //d=ifs[i].getPreferredSize();
                    sx=Math.max(sx1,delta);
                    sy=Math.max(sy1,delta);

                    ifs[i].setLocation((layer%mod)*delta,(layer%mod)*delta);
                    ifs[i].setSize(sx,sy);

                }
            scrollpane.updateScroll();
        }


        public void tile()
        {
            Rectangle r;
            Dimension d;
            int layer;

            restaurer();
            r=scrollpane.getViewport().getViewRect();

            JInternalFrame[] ifs=jDesktopPane.getAllFrames();
            if(ifs.length<=0)
                return;
            int nbcotey=(int)Math.floor(Math.sqrt(ifs.length-1))+1;
            int nbcotex=(ifs.length-1)/(nbcotey) + 1;
            int delta=getTitleBarHeight(ifs[0]);

            int i=0;
            for(int y=0;y<nbcotey;y++)
                for(int x=0;((x<nbcotex)&&(i<ifs.length));x++)
                    {
                        ifs[i].setLocation( (x*(int)r.getWidth())/nbcotex,(y*(int)r.getHeight())/nbcotey);
                        ifs[i].setSize((int)r.getWidth()/nbcotex,(int)r.getHeight()/nbcotey);
                        i++;
                    }
            scrollpane.updateScroll();
        }

        public ToolkitKarto getToolkitKarto()
        {
            return toolkit;
        }

        public Document getCurrentDocument()
        {
            if(maximizedComponent!=null)
                {
                    return (Document)((JScrollPane)maximizedComponent).getViewport().getView();
                }
            if(jDesktopPane.getSelectedFrame()==null)
                return null;
            //JScrollPane s=(JScrollPane)jDesktopPane.getSelectedFrame().getContentPane().getComponent(0).getComponent(0);
            return (Document)((JScrollPane)jDesktopPane.getSelectedFrame().getContentPane().getComponent(0)).getViewport().getView();
        }

        public DocumentKarto getCurrentDocumentKarto()
        {
            return currentDocumentKarto;
        }

        public DocumentKartoContainer nextDocumentKartoContainer()
        {
            return this;
        }


        // DocumentKartoContainer

        public DocumentMNTContainer nextDocumentMNTContainer()
        {
            return this;
        }

        public void addSelectDocumentMNTListener(SelectDocumentListener l)
        {
            documentMNTListener.add(l);
        }

        public void removeSelectDocumentMNTListener(SelectDocumentListener l)
        {
            documentMNTListener.remove(l);
        }


        public void notifySelectDocumentMNTListener(DocumentMNT doc)
        {
            currentDocumentMNT=doc;
            //toolBar.setVisible(false);
            //showLeftPanel(false);
            for(int i=0;i<documentMNTListener.size();i++ )
                {
                    ((SelectDocumentListener)(documentMNTListener.elementAt(i))).documentSelected(doc);
                }
        }
        Vector documentMNTListener;

        public DocumentMNT getCurrentDocumentMNT()
        {
            return currentDocumentMNT;
        }

        DocumentMNT currentDocumentMNT;

        public void actionPerformed(ActionEvent e)
        {

            if(e.getSource()==menuitemquit)
                {
                    dispose();
                    java.lang.System.exit(0);
                }

            if(e.getSource()==cascade)
                {
                    cascade();
                }
            if(e.getSource()==tile)
                {
                    tile();
                }

            if(e.getSource()==restaurer)
                {
                    restaurer();
                }
            if(e.getSource()==reduire)
                {
                    iconify(maximizedFrame);
                }
            if(e.getSource()==fermer)
                {
                    closeFrame(maximizedFrame);
                }


        }


        public void addSelectDocumentKartoListener(SelectDocumentListener l)
        {
            documentListener.add(l);
        }

        public void removeSelectDocumentKartoListener(SelectDocumentListener l)
        {
            documentListener.remove(l);
        }

        public void notifyNoDocument()
        {
            notifySelectDocumentKartoListener(null);
        }

        public void notifySelectDocumentKartoListener(DocumentKarto doc)
        {
            currentDocumentKarto=doc;
            for(int i=0;i<documentListener.size();i++ )
                {
                    ((SelectDocumentListener)(documentListener.elementAt(i))).documentSelected(doc);
                }
        }

        public void setContextualToolbar(JComponent component)
        {
            contextualToolBar.removeAll();
            if(component!=null)
                {
                    contextualToolBar.add(component);
                    contextualToolBar.setVisible(true);
                }
            else
                {
                    contextualToolBar.setVisible(false);
                }
            validate();
            repaint();
        }

        public void setDocumentName(Document doc,String name)
        {
            JInternalFrame[] ifs=jDesktopPane.getAllFrames();

            for(int i=0;i<ifs.length;i++)
                {
                    if((ifs[i].getContentPane().getComponentCount()==0) && (maximizedComponent==doc))
                        {
                            ifs[i].setTitle(name);
                            if(!name.equals(""))
                                setTitle(title+" ("+name+")");
                        }
                    else if(ifs[i].getContentPane().getComponent(0)==doc)
                        {
                            ifs[i].setTitle(name);
                        }
                }
            /*if((maximizedComponent==doc)&&(name!=null))
                {if(!name.equals("")) setTitle(title+" ("+name+")");
                }*/
        }

        protected Vector documentListener;


        // windowlistener
        public void windowActivated(WindowEvent e)
        {}
        public void windowClosed(WindowEvent e)
        {}
        public void windowClosing(WindowEvent e)
        {
            dispose();
            java.lang.System.exit(0);
        }
        public void windowDeactivated(WindowEvent e)
        {}
        public void windowDeiconified(WindowEvent e)
        {}
        public void windowIconified(WindowEvent e)
        {}
        public void windowOpened(WindowEvent e)
        {}



        private JMenuBar createmenu(ActionToolContextual actionSelectColor,ActionSelectAltitudeMulti actionSelectAltitudeMulti,
                                    JToggleButton buttonSelectColor
                                   )
        {
            JMenu[] menu=new JMenu[5];
            JMenuBar menubar=new JMenuBar();
            ActionImportImage importImage=new ActionImportImage(this,this);

            int menui=0;
            menu[menui]=new JMenu(ResourceManager.get("file"));

            //menu[menui].add(new JMenuItem(new ActionOpen(this,this,importImage)));
            
            menu[menui].add(new JMenuItem(new ActionOpen(this,this,this,importImage)));
           
           // menu[menui].add(new JMenuItem(new ActionSaveAs(this,this)));
           // menu[menui].add(new JMenuItem(new ActionSave(this,this)));
            ActionSave actionSave=new ActionSave(this,this);
            menu[menui].add(new JMenuItem(new ActionSaveAs(this,this,actionSave)));
            menu[menui].add(new JMenuItem(actionSave));

            //menui++;
            //menu[menui]=new JMenu("Export");
            menu[menui].addSeparator();

            menu[menui].add(new JMenuItem(importImage));
            menu[menui].add(new JMenuItem(new ActionChargerLignes(this,this)));
            menu[menui].add(new JMenuItem(new ActionSauvegarde(this,this)));
            menu[menui].add(new JMenuItem(new ActionAdaptSize(this)));

            //menu[menui].add(new JMenuItem(new ActionExportVrml (this)));

            menu[menui].addSeparator();
            menuitemquit=new JMenuItem(ResourceManager.get("quit"));
            menuitemquit.addActionListener(this);
            menu[menui].add(menuitemquit);

            menui++;
            menu[menui]=new JMenu(ResourceManager.get("zoom"));
            zoom=new double[3*6];
            int i=0,j;
            double mult;

            mult=0.1;
            for(j=0;j<3;j++)
                {
                    zoom[i++]=1*mult;
                    zoom[i++]=1.5*mult;
                    zoom[i++]=2.0*mult;
                    zoom[i++]= 2.5*mult;
                    zoom[i++]= 5*mult;
                    zoom[i++]= 7.5*mult;
                    mult=mult*10.0;
                }

            ButtonGroup bg=new ButtonGroup();
            for(i=0;i<zoom.length;i++)
                {

                    ActionZoom actionZoom=new ActionZoom(this,this,zoom[i]);
                    JCheckBoxMenuItem2 z=new JCheckBoxMenuItem2(actionZoom);
                    menu[menui].add(z);
                    bg.add(z);

                }

            menui++;
            menu[menui]=new JMenu(ResourceManager.get("options"));

            ActionSetInterpolationType actionSetInterpolationType=new ActionSetInterpolationType(this,this);
            menu[menui].add(new JCheckBoxMenuItem2(actionSetInterpolationType));

            menu[menui].add(new JMenuItem(new ActionBackgroundColor(this)));
            menu[menui].add(new JMenuItem(new ActionLinesColor(this)));

            menui++;
            menu[menui]=new JMenu(ResourceManager.get("tools"));
            /*ActionFilter actionFilter=new ActionFilter(this);
            menu[3].add(new JMenuItem(actionFilter));
            ActionFilter2 actionFilter2=new ActionFilter2(this);
            menu[3].add(new JMenuItem(actionFilter2));

            ActionFilter3 actionFilter3=new ActionFilter3(this);
            menu[3].add(new JMenuItem(actionFilter3));*/

            JMenuItem jmenuItem;
            //ActionContour actionContour=new ActionContour(this,this,actionSelectColor,buttonSelectColor);
            ActionShowDialog1 actionContour=new ActionShowDialog1(this,this,"Lignes de niveaux...",new ContourDialog(this,this,actionSelectColor,buttonSelectColor));

            menu[menui].add(new JMenuItem(actionContour));
            //menu[menui].add(new JMenuItem(new ActionCalques(this,this)));
            menu[menui].add(new JMenuItem( new ActionShowDialog2(this,this,"Calques...",new CalquesDialog(this),"Calques")));

            //menu[menui].add(new JMenuItem(new ActionBrushOptions(this,this,toolkit)));
            menu[menui].add(jmenuItem=new JMenuItem("Palette d'altitude..."));
            //jmenuItem.addActionListener(new ActionPaletteAltitude(this,this));
            PaletteAltitudeDialog pad;
            jmenuItem.addActionListener(new ActionShowDialog2(this,this,"PaletteAltitude...",
                                        pad=new PaletteAltitudeDialog(this,true),"Palette d'altitude"));
            addSelectDocumentMNTListener(pad);

            //menu[menui].add(jmenuItem=new JMenuItem("Altitude..."));
            //ActionAltitudeDialog actionAltitudeDialog;
            //jmenuItem.addActionListener(actionAltitudeDialog=new ActionAltitudeDialog(this,this,actionSelectAltitudeMulti));
            //actionSelectAltitudeMulti.setAltitudeDialog(actionAltitudeDialog.getAltitudeDialog());

            menu[menui].add(new JMenuItem(new ActionThinning(this)));
            menu[menui].add(new JMenuItem(new ActionCleaning(this)));
            ActionSobel actionFilter3=new ActionSobel(this);
            menu[menui].add(new JMenuItem(actionFilter3));
            //menu[menui].add(new JMenuItem(new ActionInterpolation(this)));


            menui++;
            menu[menui]=new JMenu("Window");
            cascade=new JMenuItem("Cascade");
            cascade.addActionListener(this);
            tile=new JMenuItem("Tile");
            tile.addActionListener(this);
            menu[menui].add(cascade);
            menu[menui].add(tile);

            for(j=0;j<menu.length;j++)
                {
                    menubar.add(menu[j]);
                }

            return menubar;

        }


        // cre un panel avec les bouton rduire,restaurer et fermer style windows
        private JPanel createMenuBouttonPanel()
        {
            menuBouttonPanel=new JPanel();/*menuBouttonPanel.setBorder(new EmptyBorder(0,0,0,0));*/
            GridBagLayout gridbag;
            menuBouttonPanel.setLayout(gridbag=new GridBagLayout());
            GridBagConstraints c = new GridBagConstraints();
            c.anchor =GridBagConstraints.CENTER;

            reduire=new MyButton(new ImageIcon("icones/reduire.gif"));
            restaurer=new MyButton(new ImageIcon("icones/restaurer.gif"));
            fermer=new MyButton(new ImageIcon("icones/fermer.gif"));

            /*reduire=new JButton(new ImageIcon("reduire.gif"));
            restaurer=new JButton(new ImageIcon("restaurer.gif"));
            fermer=new JButton(new ImageIcon("fermer.gif"));

            reduire.setFocusPainted(false);
            restaurer.setFocusPainted(false);
            fermer.setFocusPainted(false);*/

            JPanel espace=new JPanel();
            espace.setPreferredSize(new Dimension(0,0));
            c.weightx=1;
            gridbag.setConstraints(espace, c);
            menuBouttonPanel.add(espace);

            c.weightx=0;
            gridbag.setConstraints(reduire, c);
            menuBouttonPanel.add(reduire);
            gridbag.setConstraints(restaurer, c);
            menuBouttonPanel.add(restaurer);
            c.insets=new Insets(0,2,0,2);
            gridbag.setConstraints(fermer, c);
            menuBouttonPanel.add(fermer);

            reduire.addActionListener(this);
            restaurer.addActionListener(this);
            fermer.addActionListener(this);
            return menuBouttonPanel;
        }


        JToolBar createToolbar(BarreEtat be,DocumentAction actionSelectColor,
                               ActionSelectAltitudeMulti actionSelectAltitudeMulti,JToggleButton buttonSelectColor)
        {

            ButtonGroup2 bg=new ButtonGroup2();

            JToolBar toolbar=new JToolBar(JToolBar.HORIZONTAL);
            JToggleButton2 b;

            DocumentAction action=new ActionToolContextual(this,"Select",new ImageIcon("icones/select.gif"),new ToolMoveCalibrationPoint(),new CalibrationDialog(this));
            toolbar.add(b=new JToggleButton2(action));

            b.setText(null) ;
            bg.add(b);

            action=new ActionToolContextual(this,"creer un point de calibration",
                                            new ImageIcon("icones/pointcalibration.gif"),new ToolAddCalibrationPoint(),new CalibrationDialog(this));
            toolbar.add(b=new JToggleButton2(action));
            b.setText(null) ;
            bg.add(b);

            toolbar.addSeparator();

            /*toolbar.add(b=new JToggleButton2(actionSelectColor));
            b.setText(null) ;bg.add(b);
            ((ToolSelectColor)actionSelectColor.getTool()).addColorListener(be);*/
            bg.add(buttonSelectColor);

            toolbar.add(b=new JToggleButton2(new ActionBrush(this,toolkit)));
            b.setText(null) ;
            bg.add(b);

            toolbar.add(b=new JToggleButton2(new ActionLine(this,toolkit)));
            b.setText(null) ;
            bg.add(b);

            toolbar.add(b=new JToggleButton2(new ActionMultiLine(this,toolkit)));
            b.setText(null) ;
            bg.add(b);

            toolbar.add(b=new JToggleButton2(new ActionEraser(this,toolkit)));
            b.setText(null) ;
            bg.add(b);

            toolbar.addSeparator();
            toolbar.add(b=new JToggleButton2(new ActionSelectAltitude(this,toolkit)));
            b.setText(null) ;
            bg.add(b);

            toolbar.add(b=new JToggleButton2(actionSelectAltitudeMulti));
            b.setText(null) ;
            bg.add(b);

            toolbar.setFloatable(true);


            return toolbar;
        }


        /*public void setAction(String name,Action2 action)
            {actionList.put(name,action);
            }
        */


        private void createInterface()
        {
            systemLookAndFeel();
            UIDefaults def = UIManager.getDefaults();
            def.put("ToggleButton.margin", new Insets(0,0,0,0));

            toolkit=new ToolkitKarto();
            maximizedFrame=null;
            addWindowListener(this);
            setIconImage(Toolkit.getDefaultToolkit().getImage("icones/kartoicon.gif"));
            getContentPane().setLayout(new BorderLayout(0,0));

            JPanel toolbarMenuPanel=new JPanel();
            JPanel toolbarPanel=new JPanel();
            toolbarPanel.setLayout(new BorderLayout(0,0));
            toolbarMenuPanel.setLayout(new BorderLayout(0,0));


            getContentPane().add(toolbarMenuPanel,BorderLayout.CENTER);
            toolbarMenuPanel.add(toolbarPanel,BorderLayout.CENTER);

            mainPanel=new JPanel();
            mainPanel.setLayout(new BorderLayout(0,0));

            toolbarPanel.add(mainPanel,BorderLayout.CENTER);

            jDesktopPane= new JDesktopPane();
            scrollpane=new JScrollDesktopPane(jDesktopPane);

            BarreEtat barreEtat=new BarreEtat(this);
            mainPanel.add(scrollpane,BorderLayout.CENTER);
            getContentPane().add(barreEtat,BorderLayout.SOUTH);

            //scrollpane.setBorder(new ReliefBorder(ReliefBorder.LOWERED,2));


            jDesktopPane.setDesktopManager(desktopManager=new MyDesktopManager(this,scrollpane));

            ActionSelectAltitudeMulti actionSelectAltitudeMulti=new ActionSelectAltitudeMulti(this);
            //actionSelectColor=new ActionSelectColor (this);
            actionSelectColor=new ActionToolContextual(this,"Selection couleur",new ImageIcon("icones/selectcolor.gif"),new ToolSelectColor(),null);


            // action de selection de couleur doit etre cre avant d'appeler createmenu et createToolbar

            JToggleButton buttonSelectColor=new JToggleButton2(actionSelectColor);
            JMenuBar menubar=createmenu(actionSelectColor,actionSelectAltitudeMulti,buttonSelectColor);

            menuPanel=new JPanel();
            menuPanel.setLayout(new BorderLayout(0,0));
            menuPanel.add(menubar,BorderLayout.WEST);
            menubar.setBorder(new EmptyBorder(0,0,0,0));
            menuPanel.add(createMenuBouttonPanel(),BorderLayout.CENTER);


            JToolBar toolbarmenu=new JToolBar(JToolBar.HORIZONTAL);
            toolbarmenu.add(menuPanel);
            toolbarMenuPanel.add(toolbarmenu,BorderLayout.NORTH);
            toolbarMenuPanel.add(contextualToolBar=new JToolBar(),BorderLayout.SOUTH);
            contextualToolBar.setVisible(false);
            ReliefBorder border;
            //toolbarmenu.setBorder(border=new ReliefBorder(ReliefBorder.RAISED));
            //border.setInsets(new Insets(1,6,1,1));

            JToolBar toolBar;
            toolbarPanel.add(toolBar=createToolbar(barreEtat,actionSelectColor,actionSelectAltitudeMulti,buttonSelectColor),BorderLayout.NORTH);

            pack();

            final MainWindowMDI win=this;
            DropFileManager dropFileManager=new DropFileManager(jDesktopPane)
                                            {
                                                void fileDropped(File file)
                                                {
                                                    KartoLoader.load(win,win,file.getAbsolutePath(),new ActionImportImage(win,win));
                                                }
                                            };
            // drag & drop
            dropFileManager.addComponent(this);
            dropFileManager.addComponent(menuPanel);
            dropFileManager.addComponent(menubar);
            dropFileManager.addComponent(toolbarPanel);
            dropFileManager.addComponent(toolBar);

            menuPanel.remove(menuBouttonPanel);
            jDesktopPane.setBackground(new Color(70,75,80));

        }


        private void systemLookAndFeel()
        {
            try
                {
                    String lnfName = UIManager.getSystemLookAndFeelClassName();
                    //String lnfName = "com.sun.java.swing.plaf.windows.WindowsLookAndFeel";
                    //String lnfName = "javax.swing.plaf.metal.MetalLookAndFeel";
                    //String lnfName = "com.sun.java.swing.plaf.motif.MotifLookAndFeel";
                    UIManager.setLookAndFeel(lnfName);
                    SwingUtilities.updateComponentTreeUI(this);

                    if(lnfName.indexOf("WindowsLookAndFeel")!=-1)
                        {
                            UIDefaults def = UIManager.getDefaults();

                            //def.put("ToolBar.border", new EmptyBorder(2,2,2,2));
                            //def.put("ToolBar.margin", new Insets(2,2,2,2));
                            ReliefBorder border=new ReliefBorder(ReliefBorder.RAISED);
                            border.setInsets(new Insets(3,3,3,3));
                            def.put("ToolBar.border",border);
                            def.put("ScrollPane.border",new ReliefBorder(ReliefBorder.LOWERED,2));
                            /*def.put("ToggleButton.margin", new Insets(0,0,0,0));
                            //def.put("ToggleButton.border", new ReliefBorder(ReliefBorder.RAISED));

                            def.put("Button.margin", new Insets(0,0,0,0));
                            def.put("MenuBar.border", new EmptyBorder(0,0,0,0));
                            //def.put("MenuBar.border", new ReliefBorder(ReliefBorder.RAISED));
                            def.put("Panel.margin", new Insets(0,0,0,0));
                            def.put("Panel.border", new EmptyBorder(0,0,0,0));*/


                            SwingUtilities.updateComponentTreeUI(this);
                        }
                }
            catch(Exception nf)
                {
                    System.out.println("impossible d'activer le look&feel Windows");
                }
        }



        // permet de recevoir les venement lis au fenetres internes
        class MyDesktopManager extends DefaultDesktopManager
            {

                public void activateFrame(JInternalFrame f)
                {
                    super.activateFrame(f);
                    //mainWindow.notifySelectDocumentListener((DocumentKarto)f.getContentPane().getComponent(0));
                    Document doc=mainWindow.getCurrentDocument();
                    if(doc!=null)
                        doc.selected();
                    scrollpane.updateScroll();
                }
                public void beginDraggingFrame(JComponent f)
                {
                    super.beginDraggingFrame(f);
                }

                public void beginResizingFrame(JComponent f, int direction)
                {
                    super.beginResizingFrame(f,direction);

                }

                public void closeFrame(JInternalFrame f)
                {
                    super.closeFrame(f);
                    if((mainWindow.getCurrentDocument()==(Document)f.getContentPane().getComponent(0))||(mainWindow.getCurrentDocument()==null))
                        mainWindow.notifyNoDocument();
                    //mainWindow.notifySelectDocumentListener(null);
                    scrollpane.updateScroll();
                }

                public void deactivateFrame(JInternalFrame f)
                {
                    super.deactivateFrame(f);
                    scrollpane.updateScroll();
                    scrollpane.updateScroll();
                }

                public void deiconifyFrame(JInternalFrame f)
                {
                    super.deiconifyFrame(f);
                    scrollpane.updateScroll();
                }

                public void dragFrame(JComponent f, int newX, int newY)
                {
                    super.dragFrame(f, newX, newY);
                }

                public void endDraggingFrame(JComponent f)
                {
                    super.endDraggingFrame(f);
                    scrollpane.updateScroll();
                }

                public void endResizingFrame(JComponent f)
                {
                    super.endResizingFrame(f);
                    scrollpane.updateScroll();
                }

                public void iconifyFrame(JInternalFrame f)
                {
                    super.iconifyFrame(f);
                    scrollpane.updateScroll();
                }

                public void maximizeFrame(JInternalFrame f)
                {
                    super.maximizeFrame(f);
                    mainWindow.maximizeFrame(f);
                    scrollpane.updateScroll();

                }

                public void minimizeFrame(JInternalFrame f)
                {
                    super.minimizeFrame(f);
                    scrollpane.updateScroll();

                }

                public void openFrame(JInternalFrame f)
                {
                    super.openFrame(f);
                    scrollpane.updateScroll();
                }

                public void resizeFrame(JComponent f, int newX, int newY, int newWidth, int newHeight)
                {
                    super.resizeFrame(f, newX, newY, newWidth, newHeight);
                    scrollpane.updateScroll();
                }

                public void setBoundsForFrame(JComponent f, int newX, int newY, int newWidth, int newHeight)
                {
                    super.setBoundsForFrame(f, newX, newY, newWidth, newHeight);
                    scrollpane.updateScroll();
                }




                MyDesktopManager(MainWindowMDI _mainWindow,JScrollDesktopPane _scrollpane)
                {
                    mainWindow=_mainWindow;
                    scrollpane=_scrollpane;
                }

                protected MainWindowMDI mainWindow;
                JScrollDesktopPane scrollpane;
            }


        JMenu[] menu;
        double[] zoom;

        JMenuItem menuitemquit,tile,cascade;

        JScrollDesktopPane scrollpane;

        JDesktopPane jDesktopPane;

        JPanel menuPanel,menuBouttonPanel;
        JMenuBar menubar;
        JToolBar contextualToolBar;

        JButton reduire,restaurer,fermer;

        private Label label;
        DocumentKarto documentkarto;

        JInternalFrame maximizedFrame;
        Component maximizedComponent;

        DesktopManager desktopManager;
        String title;

        JPanel mainPanel;

        ActionToolContextual actionSelectColor;


        Hashtable actionList;
        ToolkitKarto toolkit;

        DocumentKarto currentDocumentKarto;

    }

