/** 
 * Fenetre principale du logiciel (Single Document Interface)
 *
 * @author HEIT Sylvestre & Coustillac Laurent
 *
 *
 * Programme kartoMNT : gnration de MNT  partir d'une carte de lignes de niveaux
 * Copyright (C) 2002  HEIT Sylvestre & Coustillac Laurent
 * 
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence
 *Publique Gnrale GNU publie par la Free Software Foundation (version 2).
 *
 *Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
 *y compris les garanties de commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
 *Licence Publique Gnrale GNU pour plus de dtails.
 *
 *Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ; si
 *ce n'est pas le cas, crivez  la
 *Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 */
package kartoMNT;

import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.io.*;

import kartoMNT.karto.outils.*;


class MainWindowSDI extends JFrame implements WindowListener,ComponentListener,ActionListener,
            DocumentKartoContainer,DocumentMNTContainer {
    
    
    static int nbWindows=0;
    static Vector mainWindowSDIlist=new Vector();

    Vector windowsList;
    Vector windowsListMenuItem;
    
    Vector documentKartoListener;
    Vector documentMNTListener;
    
    
    protected JMenuItem menuitemquit,close;
    protected ToolkitKarto toolkit;
    protected JPanel mainPanel;
    protected JPanel menuPanel;
    protected JToolBar contextualToolBar;
    protected JToolBar toolBar;
    protected JComponent centerPanel;   //composant cental (document)
    protected JComponent emptypanel;
    protected JScrollPane jScrollPane;

    protected DocumentKarto currentDocumentKarto;
    protected DocumentMNT currentDocumentMNT;
    protected Document currentDocument;

    protected String title;
    protected JMenu windowsListMenu;
    protected DropFileManager dropFileManager;

    protected JPanel leftPanel;
    protected PaletteAltitudeDialog paletteAltitudeDialog;
    protected ActionSet actionSet;

    protected SelectDocumentListener barreEtat;
    protected BarreEtat barreEtatDoc;

	
	JMenu localeMenu;

	/**
	 * Constructeur
	 */
    MainWindowSDI(){
    	    	
        addWindowListener(this);
        addComponentListener(this);
        nbWindows++;
        documentMNTListener=new Vector();
        documentKartoListener=new Vector();
        createInterface();
        title="KartoMNT";
        setTitle(title);

        windowsList=new Vector();
        windowsListMenuItem=new Vector();
        mainWindowSDIlist.add(this);
        updateAllWindowsMenu();
        //windowsListMenu.setEnabled(false);
        notifySelectNoDocument();
    }

    // WindowListener    
    public void windowActivated(WindowEvent e){}

    public void windowClosed(WindowEvent e){}

    public void windowClosing(WindowEvent e){
        notifySelectNoDocument();
        nbWindows--;
        mainWindowSDIlist.remove(this);
        updateAllWindowsMenu();
        if(nbWindows==0){
                dispose();
                java.lang.System.exit(0);
        }
    }

    public void windowDeactivated(WindowEvent e){}

    public void windowDeiconified(WindowEvent e){}

    public void windowIconified(WindowEvent e){}

    public void windowOpened(WindowEvent e){}


    // ComponentListener

    public void componentHidden(ComponentEvent e){}

    public void componentMoved(ComponentEvent e){}

    public void componentResized(ComponentEvent e){}

    public void componentShown(ComponentEvent e){}


    // DocumentKartoContainer
    
    public void addSelectDocumentKartoListener(SelectDocumentListener l){
        documentKartoListener.add(l);
    }

    public void removeSelectDocumentKartoListener(SelectDocumentListener l){
        documentKartoListener.remove(l);
    }

    public void notifySelectDocumentKartoListener(DocumentKarto doc){
        currentDocumentKarto=doc;
        toolBar.setVisible(doc!=null);
        showLeftPanel(doc!=null);
        if(barreEtat!=null){
                getContentPane().remove((JPanel)barreEtat);
                removeSelectDocumentMNTListener(barreEtat);
                removeSelectDocumentKartoListener(barreEtat);
        }

        if(doc==null)
            setContextualToolbar(null);

        getContentPane().add((JPanel)(barreEtat=barreEtatDoc),BorderLayout.SOUTH);
        addSelectDocumentKartoListener(barreEtat);

        for(int i=0;i<documentKartoListener.size();i++ ){
        	((SelectDocumentListener)(documentKartoListener.elementAt(i))).documentSelected(doc);
        }
    }
    
    
    // DocumentMNTContainer
    public void addSelectDocumentMNTListener(SelectDocumentListener l){
        documentMNTListener.add(l);
    }

    public void removeSelectDocumentMNTListener(SelectDocumentListener l){
        documentMNTListener.remove(l);
    }

    public void notifySelectDocumentMNTListener(DocumentMNT doc){
        currentDocumentMNT=doc;
        toolBar.setVisible(false);
        showLeftPanel(false);

        if(barreEtat!=null){
        	getContentPane().remove((JPanel)barreEtat);
            removeSelectDocumentMNTListener(barreEtat);
            removeSelectDocumentKartoListener(barreEtat);
       	}

        if(doc!=null){
            getContentPane().add((JPanel)(barreEtat=new BarreEtatMNT(this)),BorderLayout.SOUTH);
            addSelectDocumentMNTListener(barreEtat);

            if(paletteAltitudeDialog==null)
                paletteAltitudeDialog=new PaletteAltitudeDialog(this,false);
            mainPanel.add(paletteAltitudeDialog,BorderLayout.SOUTH);
            paletteAltitudeDialog.documentSelected(currentDocumentMNT);
        } else { 
        	if(paletteAltitudeDialog!=null){
            	mainPanel.remove(paletteAltitudeDialog);
                paletteAltitudeDialog.documentSelected(null);
                paletteAltitudeDialog=null;
            }
            setContextualToolbar(null);
        }

        for(int i=0;i<documentMNTListener.size();i++ ){
        	((SelectDocumentListener)(documentMNTListener.elementAt(i))).documentSelected(doc);
        }
    }
    

    public void notifySelectNoDocument(){
        notifySelectDocumentKartoListener(null);
        notifySelectDocumentMNTListener(null);
    }


    /**
     * Renvoie le document courant
     */
    public Document getCurrentDocument(){
        return currentDocument;
    }

    /**
     * Renvoie le document Karto courant (null si pas de document ou document d'un autre type)
     */
    public DocumentKarto getCurrentDocumentKarto(){
        return currentDocumentKarto;
    }

   	/**
   	 * Renvoie le document Karto courant (null si pas de document ou document d'un autre type)
   	 */
    public DocumentMNT getCurrentDocumentMNT(){
        return currentDocumentMNT;
    }


    public void addDocument(Document doc){
        addDocument(doc,"");
    }

    public void showLeftPanel(boolean b){
        leftPanel.setVisible(b);
    }

    private void setCenterComponent(JComponent comp){
        centerPanel=comp;
        jScrollPane.setViewportView(comp);
    }

    private void removeCenterComponent(){
        centerPanel=emptypanel;
        jScrollPane.setViewportView(centerPanel);

    }

    protected MainWindowSDI addWindow(){
        MainWindowSDI window=new MainWindowSDI();

        Point p=getLocationOnScreen();
        window.setLocation(p.x, p.y);
        window.setSize(getSize());

        window.show();
        return window;
    }

    public DocumentKartoContainer nextDocumentKartoContainer(){
        if(getCurrentDocument()==null)
            return this;
        else
            return addWindow();
    }
    
    public DocumentMNTContainer nextDocumentMNTContainer(){
        if(getCurrentDocument()==null)
            return this;
        else
            return addWindow();
    }

    public void addDocument(Document doc,String name){
        if(doc==null)
            return;
        MainWindowSDI window;
        if(currentDocument!=null){
        	window=addWindow();
            window.addDocument(doc,name);
        }else{
            close.setEnabled(true);
            //doc.setDocumentKartoContainer(this); //???
            doc.selected();

            setCenterComponent((JComponent)doc);
            currentDocument=doc;
            if(doc.getName()!=null){
              	if(!doc.getName().equals(""))
           			setTitle(title+" ["+doc.getName()+"]");
            }
            updateAllWindowsMenu();
            dropFileManager.addComponent((JComponent)currentDocument);
            validate();
            repaint();
        }
    }
	
	
	/**
	 * Fixe le nom du document
	 */
    public void setDocumentName(Document doc,String name){
        if(doc==null)
            return;
        if(currentDocument==doc){
            if(doc.getName()!=null){
            	if(!doc.getName().equals(""))
                	setTitle(title+" ["+doc.getName()+"]");
        	}
        	setTitle(title+" ["+name+"]");
        }
        updateAllWindowsMenu();
    }

    
    public void setContextualToolbar(JComponent component){
        contextualToolBar.removeAll();
        if(component!=null){
            contextualToolBar.add(component);
            contextualToolBar.setVisible(true);
        }else{
         	contextualToolBar.setVisible(false);
      	}
        validate();
        repaint();
    }

    private void toFront(JFrame win){
        if (win.getState()==Frame.ICONIFIED){
            win.setState(Frame.NORMAL);
            Point p=getLocationOnScreen();
            win.setLocation(p.x, p.y);
            win.setSize(getSize());
        }
        win.toFront();
    }


	//////////////////
    //ActionListener//
    //////////////////
    public void actionPerformed(ActionEvent e){

        if(e.getSource()==menuitemquit){
            dispose();
            java.lang.System.exit(0);
        }

        if(e.getSource()==close){
            if(nbWindows>1){
            	
                nbWindows--;
                notifySelectNoDocument();
                mainWindowSDIlist.remove(this);
                updateAllWindowsMenu();
                toFront((MainWindowSDI)windowsList.get(windowsList.size()-1));
                dispose();
                
            } else if (nbWindows==1){
                notifySelectNoDocument();
                removeCenterComponent();
                currentDocument=null;
                notifySelectNoDocument();
                setTitle(title);
                updateAllWindowsMenu();
                close.setEnabled(false);
                validate();
                repaint();
            }
        }
        
        int i;
        for(i=0;i<windowsListMenuItem.size();i++){
            if(e.getSource()==windowsListMenuItem.get(i)){
                MainWindowSDI win=((MainWindowSDI)windowsList.get(i));
                toFront(win);
            }
        }
    }


	/**
	 * Mise  jour des menus de toutes les fentres ouvertes
	 */
    public static void updateAllWindowsMenu(){
        int j;
        for(j=0;j<mainWindowSDIlist.size();j++){
        	((MainWindowSDI)mainWindowSDIlist.get(j)).updateWindowsMenu();
        }
    }

	/**
	 * Mise  jour des menus
	 */
    public void updateWindowsMenu(){
        
        windowsListMenu.removeAll();
        windowsList.clear();
        windowsListMenuItem.clear();
        int j,d=0;
        boolean exist=false;
        for(j=0;j<mainWindowSDIlist.size();j++){
            MainWindowSDI win=(MainWindowSDI) mainWindowSDIlist.get(j);

            if(win.getCurrentDocument()!=null){
                String name=win.getCurrentDocument().getName();
                if(name==null){
                    d++;
                    name = ResourceManager.get("doc")+" "+d;
                }
                JMenuItem item=new JMenuItem(""+(j+1)+". " +name );
                item.addActionListener(this);
                windowsListMenu.add(item);

                windowsListMenuItem.add(item);
                windowsList.add(win);
                exist=true;
            }
        }
        windowsListMenu.setVisible(exist);
    }

	/**
	 * Creation du menu avec affectation des actions
	 */    
    private JMenuBar createmenu(ActionSet actionSet,ActionToolContextual actionSelectColor,
                                JToggleButton buttonSelectColor,ActionToolContextual actionSelectRegion,
                                JToggleButton buttonSelectRegion){

        JMenu[] menu=new JMenu[8];
        JMenuBar menubar=new JMenuBar();
        ActionImportImage importImage=new ActionImportImage(this,this);

        int menui=0;
        menu[menui]=new JMenu(ResourceManager.get("file"));
		
		menu[menui].add(new JMenuItem(new ActionOpen(this,this,this,importImage)));
        
        //menu[menui].add(new JMenuItem(new ActionOpen(this,this,importImage)));
        
        //menu[menui].add(new JMenuItem(new ActionSaveAs(this,this)));
        //menu[menui].add(new JMenuItem(new ActionSave(this,this)));
        
        ActionSave actionSave=new ActionSave(this,this);
        menu[menui].add(new JMenuItem(new ActionSaveAs(this,this,actionSave)));
        menu[menui].add(new JMenuItem(actionSave));
        
        menu[menui].add(new JMenuItem(new ActionExportMNT(this,this)));
        menu[menui].add(close=new JMenuItem(ResourceManager.get("close")));
        close.setEnabled(false);
        close.addActionListener(this);

        menu[menui].addSeparator();

        menu[menui].add(new JMenuItem(importImage));
        menu[menui].add(new JMenuItem(new ActionChargerLignes(this,this)));
        menu[menui].add(new JMenuItem(new ActionSauvegarde(this,this)));
        menu[menui].add(new JMenuItem(new ActionAdaptSize(this)));

        menu[menui].addSeparator();
        menuitemquit=new JMenuItem(ResourceManager.get("quit"));
        menuitemquit.addActionListener(this);
        menu[menui].add(menuitemquit);


        menui++;
        menu[menui]=new JMenu(ResourceManager.get("tools"));
        menu[menui].add(new JCheckBoxMenuItem2(actionSet.action1));
        menu[menui].add(new JCheckBoxMenuItem2(actionSet.action2));
        menu[menui].add(new JCheckBoxMenuItem2(actionSet.action3));
        menu[menui].add(new JCheckBoxMenuItem2(actionSet.action4));
        menu[menui].add(new JCheckBoxMenuItem2(actionSet.action5));
	menu[menui].add(new JCheckBoxMenuItem2(actionSet.action11));
        menu[menui].add(new JCheckBoxMenuItem2(actionSet.action6));
        menu[menui].add(new JCheckBoxMenuItem2(actionSet.action7));
        menu[menui].add(new JCheckBoxMenuItem2(actionSet.action8));
        menu[menui].add(new JCheckBoxMenuItem2(actionSet.action9));
        menu[menui].add(new JCheckBoxMenuItem2(actionSet.action10));
	
        menui++;
        menu[menui]=new JMenu(ResourceManager.get("lines"));

        ActionShowDialog1 actionContour=new ActionShowDialog1(this,this,ResourceManager.get("detect"),
                                        new ContourDialog(this,this,actionSelectColor,buttonSelectColor));
        menu[menui].add(new JMenuItem(actionContour));
        menu[menui].add(new JMenuItem(new ActionThinning(this)));
        menu[menui].add(new JMenuItem(new ActionCleaning(this)));
	menu[menui].add(new JMenuItem(new ActionClearAll(this,this)));
        ActionSobel actionFilter3=new ActionSobel(this);
        menu[menui].add(new JMenuItem(actionFilter3));

        menui++;
        menu[menui]=new JMenu(ResourceManager.get("mnt"));

        ActionShowDialog1 actionInterpol=new ActionShowDialog1(this,this,ResourceManager.get("genMNT"),
                                         new InterpolationDialog(this,this,this,actionSelectRegion,buttonSelectRegion));
        menu[menui].add(new JMenuItem(actionInterpol ));
        
        menu[menui].add(new JCheckBoxMenuItem2(new ActionSuperpose(this,this)));
        
        menu[menui].add(new JMenuItem(new ActionFusion(this,this,this)));

	
		menu[menui].add(new JMenuItem(new ActionVisu3D(this,this,this)));

        menui++;
        menu[menui]=new JMenu(ResourceManager.get("zoom"));
        double[] zoom=new double[3*6];
        int i=0,j;
        double mult;

        mult=0.1;
        for(j=0;j<3;j++){
            zoom[i++]=1*mult;
            zoom[i++]=1.5*mult;
            zoom[i++]=2.0*mult;
            zoom[i++]= 2.5*mult;
            zoom[i++]= 5*mult;
            zoom[i++]= 7.5*mult;
            mult=mult*10.0;
        }

        ButtonGroup bg=new ButtonGroup();
        for(i=0;i<zoom.length;i++){
            ActionZoom actionZoom=new ActionZoom(this,this,zoom[i]);
            JCheckBoxMenuItem2 z=new JCheckBoxMenuItem2(actionZoom);
            menu[menui].add(z);
            bg.add(z);
        }

        menui++;
        menu[menui]=new JMenu(ResourceManager.get("options"));

        ActionSetInterpolationType actionSetInterpolationType=new ActionSetInterpolationType(this,this);
        menu[menui].add(new JCheckBoxMenuItem2(actionSetInterpolationType));
		
	
		menu[menui].addSeparator();
		
        menu[menui].add(new JMenuItem(new ActionBackgroundColor(this)));
        menu[menui].add(new JMenuItem(new ActionLinesColor(this)));

        menu[menui].add(new JMenuItem(new ActionShowDialog2(this,this,ResourceManager.get("altPalette"),
                                      new PaletteAltitudeDialog(this,true),ResourceManager.get("altPalette"))));

        menu[menui].add(new JMenuItem(new ActionShowDialog(this,this,ResourceManager.get("optCarroyage"),new CarroyageDialog(this,this,false))));


        menui++;
        windowsListMenu=menu[menui]=new JMenu(ResourceManager.get("windows"));

        menui++;
     	menu[menui]=new JMenu(ResourceManager.get("help"));
     	menu[menui].add(new JMenuItem(new ActionHelp()));


        for(j=0;j<menu.length;j++){
        	menubar.add(menu[j]);
      	}
      	 
        return menubar;
    }

	
	

    
    /**
     * Creation de la barre d'outils
     */
    JToolBar createToolbar(ActionSet actionSet,JToggleButton buttonSelectColor,JToggleButton buttonSelectRegion){

        ButtonGroup2 bg=new ButtonGroup2();

        JToolBar toolbar=new JToolBar(JToolBar.HORIZONTAL);
        JToggleButton2 b;

        toolbar.add(b=new JToggleButton2(actionSet.action1));
        b.setToolTipText(ResourceManager.get("movePoint"));
        b.setText(null) ;
        bg.add(b);

        toolbar.add(b=new JToggleButton2(actionSet.action2));
        b.setToolTipText(ResourceManager.get("createPoint"));
        b.setText(null) ;
        bg.add(b);

        toolbar.addSeparator();

        toolbar.add(b=new JToggleButton2(actionSet.action3));
        b.setToolTipText(ResourceManager.get("toolBrush"));
        b.setText(null) ;
        bg.add(b);

        toolbar.add(b=new JToggleButton2(actionSet.action4));
        b.setToolTipText(ResourceManager.get("toolLine"));
        b.setText(null) ;
        bg.add(b);

        toolbar.add(b=new JToggleButton2(actionSet.action5));
        b.setToolTipText(ResourceManager.get("toolBrLine"));
        b.setText(null) ;
        bg.add(b);

	toolbar.add(b=new JToggleButton2(actionSet.action11));
        b.setToolTipText(ResourceManager.get("toolRabLine"));
        b.setText(null) ;
        bg.add(b);

        bg.add(buttonSelectColor);
        bg.add(buttonSelectRegion);

        toolbar.add(b=new JToggleButton2(actionSet.action6));
        b.setToolTipText(ResourceManager.get("toolGom"));
        b.setText(null) ;
        bg.add(b);

        toolbar.addSeparator();
        toolbar.add(b=new JToggleButton2(actionSet.action7));
        b.setToolTipText(ResourceManager.get("defAltLine"));
        b.setText(null) ;
        bg.add(b);

        toolbar.add(b=new JToggleButton2(actionSet.action8));
        b.setToolTipText(ResourceManager.get("defAltLines"));
        b.setText(null) ;
        bg.add(b);

        toolbar.add(b=new JToggleButton2(actionSet.action9));
        b.setToolTipText(ResourceManager.get("defAltP"));
        b.setText(null) ;
        bg.add(b);

        toolbar.addSeparator();

        toolbar.add(b=new JToggleButton2(actionSet.action10));
        b.setToolTipText(ResourceManager.get("estimAlt"));
        b.setText(null) ;
        bg.add(b);

        bg.add(buttonSelectColor);
        bg.add(buttonSelectRegion);

	

        toolbar.setFloatable(true);


        return toolbar;
    }


	/**
	 * Cre l'interface de kartoMNT
	 */
    private void createInterface(){
        
        systemLookAndFeel();

        UIDefaults def = UIManager.getDefaults();
        def.put("ToggleButton.margin", new Insets(0,0,0,0));

        toolkit=new ToolkitKarto();

        setIconImage(Toolkit.getDefaultToolkit().getImage("icones/kartoicon.gif"));
        getContentPane().setLayout(new BorderLayout(0,0));


        JPanel toolbarMenuPanel=new JPanel();
        toolbarMenuPanel.setLayout(new BorderLayout(0,0));
        getContentPane().add(toolbarMenuPanel,BorderLayout.CENTER);

        JPanel toolbarPanel=new JPanel();
        toolbarPanel.setLayout(new BorderLayout(0,0));
        toolbarMenuPanel.add(toolbarPanel,BorderLayout.CENTER);

        JPanel toolbarPanel1=new JPanel();
        toolbarPanel1.setLayout(new BorderLayout());
        toolbarPanel.add(toolbarPanel1,BorderLayout.CENTER);

        mainPanel=new JPanel();
        mainPanel.setLayout(new BorderLayout(0,0));
        toolbarPanel1.add(mainPanel,BorderLayout.CENTER);

        emptypanel=new JPanel();
        emptypanel.setBackground(new Color(70,75,80));
        centerPanel=emptypanel;

        jScrollPane=new JScrollPane();
        jScrollPane.getViewport().setOpaque(true);

        mainPanel.add(jScrollPane,BorderLayout.CENTER);
        jScrollPane.setViewportView(centerPanel);
        CalquesDialog cd=new CalquesDialog(this);
        cd.setBorder(new TitledBorder(ResourceManager.get("listCalc")));
        addSelectDocumentKartoListener(cd);
        
        leftPanel=new JPanel();
        leftPanel.setLayout(new BorderLayout());

        leftPanel.add(cd,BorderLayout.NORTH);
        CalibrationDialog2 calibrd=new CalibrationDialog2(false,CalibrationDialog2.VERTICAL);
        addSelectDocumentKartoListener(calibrd);
        calibrd.setBorder(new TitledBorder(ResourceManager.get("calibPoints")));
        leftPanel.add(calibrd,BorderLayout.CENTER);
        mainPanel.add(leftPanel,BorderLayout.EAST);

        barreEtatDoc=new BarreEtat(this);
        
        ActionSelectAltitudeMulti actionSelectAltitudeMulti=new ActionSelectAltitudeMulti(this);

        ActionSet actionSet=new ActionSet(this,barreEtatDoc,toolkit);
        
        ActionToolContextual actionSelectColor=new ActionToolContextual(this,ResourceManager.get("selecColor"),
                                               new ImageIcon("icones/selectcolor.gif"),new ToolSelectColor(),null);
        
        JToggleButton buttonSelectColor=new JToggleButton2(actionSelectColor);

        SelectionRegion selectionRegion=new SelectionRegion();
        ActionToolContextual actionSelectRegion=new ActionToolContextual(this,ResourceManager.get("calibPoints"),
                                                new ImageIcon("icones/selectregion.gif"),new ToolSelectRegionMNT(selectionRegion),null);
        JToggleButton buttonSelectRegion=new JToggleButton2(actionSelectRegion);
        buttonSelectRegion.setText(null) ;

        JMenuBar menubar=createmenu(actionSet,actionSelectColor,buttonSelectColor,actionSelectRegion,buttonSelectRegion);

        menuPanel=new JPanel();
        menuPanel.setLayout(new BorderLayout(0,0));
        menuPanel.add(menubar,BorderLayout.WEST);
        menubar.setBorder(new EmptyBorder(0,0,0,0));

        JToolBar toolbarmenu=new JToolBar(JToolBar.HORIZONTAL);
        toolbarmenu.add(menuPanel);
        toolbarMenuPanel.add(toolbarmenu,BorderLayout.NORTH);

        ReliefBorder border;


        toolbarPanel1.add(contextualToolBar=new JToolBar(),BorderLayout.SOUTH);
        contextualToolBar.setVisible(false);

        toolbarPanel.add(toolBar=createToolbar(actionSet,buttonSelectColor,buttonSelectRegion),BorderLayout.NORTH);

        toolBar.setVisible(false);
        showLeftPanel(false);

        pack();

        final MainWindowSDI win=this;

        dropFileManager=new DropFileManager(){
                            void fileDropped(File file){
                                KartoLoader.load(win,win,file.getAbsolutePath(),new ActionImportImage(win,win));
                            }
                        };
        // drag & drop
        dropFileManager.addComponent(centerPanel);
        dropFileManager.addComponent(menuPanel);
        dropFileManager.addComponent(menubar);
        dropFileManager.addComponent(toolbarPanel);
        dropFileManager.addComponent(toolBar);
        systemLookAndFeel();
    }

    private void systemLookAndFeel(){
        try {
            String lnfName = UIManager.getSystemLookAndFeelClassName();
            UIManager.setLookAndFeel(lnfName);
            SwingUtilities.updateComponentTreeUI(this);
            UIDefaults def = UIManager.getDefaults();

            //def.put("ScrollPane.border",new EmptyBorder(0,0,0,0));

            if(lnfName.indexOf("WindowsLookAndFeel")!=-1){
                if((java.lang.System.getProperty("java.version").indexOf("1.0")==0)
                        ||(java.lang.System.getProperty("java.version").indexOf("1.1")==0)
                        ||(java.lang.System.getProperty("java.version").indexOf("1.2")==0)
                        ||(java.lang.System.getProperty("java.version").indexOf("1.3")==0)
                  ) {
                    
                    //def.put("SplitPane.border",new ReliefBorder(ReliefBorder.LOWERED,2));
                    //def.put("ScrollPane.border",new EmptyBorder(0,0,0,0));
                    ReliefBorder border=new ReliefBorder(ReliefBorder.RAISED);
                    border.setInsets(new Insets(3,3,3,3));
                    def.put("ToolBar.border",border);
                    def.put("ScrollPane.border",new ReliefBorder(ReliefBorder.LOWERED,2));
                    SwingUtilities.updateComponentTreeUI(this);
                }
            }
            
        } catch(Exception nf){
            System.out.println("LookAndFeel error: " + ResourceManager.get("lookAndFeelError"));
        }
    }  
}


class ActionSet{
	
	public ActionToolContextual action1;
    public ActionToolContextual action2;
    public ActionBrush action3;
    public ActionLine action4;
    public ActionMultiLine action5;
    public ActionEraser action6;
    public ActionSelectAltitude action7;
    public ActionSelectAltitudeMulti action8;
    public ActionSommet action9;
    public ActionToolContextual action10;
    public ActionSemiAuto action11;

    ActionSet(DocumentKartoContainer c1,BarreEtat be,ToolkitKarto toolkit){

        action1=new ActionToolContextual(c1,ResourceManager.get("movePoint"),new ImageIcon("icones/select.gif"),new ToolMoveCalibrationPoint(),new CalibrationDialog(c1));
        action2=new ActionToolContextual(c1,ResourceManager.get("createPoint"),
                                         new ImageIcon("icones/pointcalibration.gif"),new ToolAddCalibrationPoint(),new CalibrationDialog(c1));
        action3=new ActionBrush(c1,toolkit);
        action4=new ActionLine(c1,toolkit);
        action5=new ActionMultiLine(c1,toolkit);
        action6=new ActionEraser(c1,toolkit);
        action7=new ActionSelectAltitude(c1,toolkit);
        action8=new ActionSelectAltitudeMulti(c1);
        action9=new ActionSommet(c1);
        action10=new ActionToolContextual(c1,ResourceManager.get("estimAlt"),
                                          new ImageIcon("icones/estimaltitude.gif"),
                                          new ToolGetAltitude(be),null);
	action11=new ActionSemiAuto(c1,toolkit);
    }
    
};

