/**
 * @author DERHI Roland
 *
 * Programme kartoMNT v2.0
 * Copyright (C) 2003  Roland DERHI & Jean BRESSON
 * 
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence
 * Publique Gnrale GNU publie par la Free Software Foundation (version 2).
 *
 * Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
 * y compris les garanties de commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
 * Licence Publique Gnrale GNU pour plus de dtails.
 *
 * Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ; si
 * ce n'est pas le cas, crivez  la
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 */
package kartoMNT;

import java.io.*;

/**
   Format de MNT
*/
public interface MntFormat extends MNTClassInterface{
    /** indicateur de format d'exportion */
    public static final int EXPORT = 1;
    /** indicateur de format d'importation */
    public static final int IMPORT = 2;

    /**
       Retourne l'extension geree par le format
       @return l'extension correspondant au format
    */
    public String getExtension();

    /**
       Retourne une description du format gere
       @return description du format ger
    */
    public String getDescription();
    /**
     * Mode de support du format
     * @return MntFormat.EXPORT si le format ne supporte que l'exportation, 
               MntFormat.IMPORT si le format ne supporte que l'importation, 
	       MntFormat.EXPORT+MntFormat.IMPORT si le format supporte l'importation et l'exportation
    */
    public int support();

    /**
       Fonction d'exportation du format
       (doit tre vide si le format ne supporte pas l'exportation)
       @param MNT le mnt  exporter
       @param filename nom du fichier o sera sauvegarder le MNT
       @throws  IOException en cas de problme d'criture du fichier
    */
    public void exportMNT (MNT mnt, String filename) throws IOException;

    /**
       Fonction d'importation du format       
       (doit tre vide si le format ne supporte pas l'importation)
       @param filename nom du fichier o sera sauvegarder le MNT
       @return le MNT import
       @throws  IOException en cas de problme de lecture du fichier
    */
    public MNT importMNT(String filename) throws IOException;

}
