/** 
 *  Boite de dialogue permettant d'diter la palette contenue dans un document
 *  Fait appel  PaletteEditor
 *   
 *  
 * 
 * @author HEIT Sylvestre & Coustillac Laurent
 *
 *
 * Programme kartoMNT : gnration de MNT  partir d'une carte de lignes de niveaux
 * Copyright (C) 2002  HEIT Sylvestre & Coustillac Laurent
 * 
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence
 *Publique Gnrale GNU publie par la Free Software Foundation (version 2).
 *
 *Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
 *y compris les garanties de commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
 *Licence Publique Gnrale GNU pour plus de dtails.
 *
 *Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ; si
 *ce n'est pas le cas, crivez  la
 *Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 */
package kartoMNT;


import javax.swing.*;
import java.awt.*;
import javax.swing.border.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.awt.image.*;
import java.text.*;


public class PaletteAltitudeDialog extends DocumentPanel
            implements SelectDocumentListener,InterpolatedPaletteListener,MultiSliderListener,ActionListener,
            DocumentListener
    {
        public PaletteAltitudeDialog(JFrame parent,boolean chooseInterval)
        {
            //super(parent);
            frame=parent;

            documentKarto=null;

            DecimalFormatSymbols sym=new DecimalFormatSymbols();
            sym.setDecimalSeparator('.');
            format=new DecimalFormat("#.###",sym);


            //setTitle("Palette d'altitude");
            jpanel=new JPanel();

            JPanel mainjpanel=this;
            //JPanel mainjpanel=new JPanel();
            //getContentPane().add(mainjpanel);
            mainjpanel.setLayout(new BorderLayout());
            mainjpanel.add(jpanel,BorderLayout.WEST);

            gridBagLayout=new GridBagLayout();
            jpanel.setLayout(gridBagLayout);

            gridBagConstraints = new GridBagConstraints();
            //gridBagConstraints.fill=GridBagConstraints.NONE;
            //gridBagConstraints.anchor =GridBagConstraints.WEST ;
            gridBagConstraints.insets=new Insets(4,4,4,4);
            gridBagConstraints.fill=GridBagConstraints.NONE;
            gridBagConstraints.gridwidth = GridBagConstraints.REMAINDER ;

            paletteEditor=new PaletteEditor(0.0,1000.0);

            paletteEditor.addColor(0,new Color(0.0f,1.0f,1.0f));


            mainjpanel.add(paletteEditor,BorderLayout.NORTH);

            if(chooseInterval)
                {
                    gridBagConstraints.gridwidth = 1;
                    addc(new JLabel(ResourceManager.get("altMin")),gridBagConstraints);
                    altMin=new JTextField( Double.toString(paletteEditor.getXmin()) );
                    altMin.setPreferredSize(new Dimension(60,(int)(altMin.getPreferredSize().getHeight())));
                    //gridBagConstraints.gridwidth = GridBagConstraints.REMAINDER;
                    addc(altMin,gridBagConstraints);

                    gridBagConstraints.gridwidth = 1;
                    addc(new JLabel(ResourceManager.get("altMax")),gridBagConstraints);
                    altMax=new JTextField( Double.toString(paletteEditor.getXmax()) );
                    altMax.setPreferredSize(new Dimension(60,(int)(altMax.getPreferredSize().getHeight())));
                    //gridBagConstraints.gridwidth = GridBagConstraints.REMAINDER;
                    addc(altMax,gridBagConstraints);

                    /*altMin.addActionListener(this);
                    altMax.addActionListener(this);*/

                    altMin.getDocument().addDocumentListener(this);
                    altMax.getDocument().addDocumentListener(this);

                    gridBagConstraints.weightx=gridBagConstraints.weighty=0;
                    gridBagConstraints.gridwidth = GridBagConstraints.REMAINDER;

                    addc(button=new JButton(ResourceManager.get("intervalAutoChoice")),gridBagConstraints);
                    button.addActionListener(this);
                }


            paletteEditor.getMultiSlider().addMultiSliderListener(this);
            paletteEditor.getPalette().addPaletteListener(this);
            oldpalette=paletteEditor.getPalette();
        }


        protected void addc(JComponent comp,GridBagConstraints c)
        {
            gridBagLayout.setConstraints(comp, c);
            jpanel.add(comp);
        }


        public void changedUpdate(DocumentEvent e)
        {
            setInterval();
        }
        public void insertUpdate(DocumentEvent e)
        {
            setInterval();
        }
        public void removeUpdate(DocumentEvent e)
        {
            setInterval();
        }

        private void setInterval()
        {
            if((altMin==null)||(altMax==null))
                return;
            try
                {
                    double min=Double.parseDouble(altMin.getText());
                    double max=Double.parseDouble(altMax.getText());
                    paletteEditor.setInterval(min,max,true );
                }
            catch(NumberFormatException e)
            {}

        }

        public void actionPerformed(ActionEvent e)
        {
            if(documentKarto!=null)
                {
                    FloatData fd=documentKarto.getFloatData();
                    if(fd!=null)
                        {
                            float max=fd.getMax();
                            float min=fd.getMin();
                            if(max>min)
                                {
                                    paletteEditor.setInterval((double)min,(double)max,true);
                                    if(altMin!=null)
                                        altMin.setText(""+min);
                                    if(altMax!=null)
                                        altMax.setText(""+max);
                                }
                        }
                }
        }

        protected void setPal()
        {
            if(documentKarto==null)
                return;
            InterpolatedPalette pal=paletteEditor.getPalette();
            FloatDataViewer ldn=documentKarto.getFloatDataViewer();
            ldn.setAltitudeMinMax((float)pal.getMinPos(),(float)pal.getMaxPos());
            ldn.setPalette(pal);
            //System.out.println("nb="+pal.getNbColor());

        }

        public void documentSelected(Document doc)
        {
            documentKarto=doc;
            if(documentKarto!=null)
                {
                    oldpalette.removePaletteListener(this);

                    oldpalette=documentKarto.getFloatDataViewer().getPalette();
                    paletteEditor.setPalette(oldpalette);
                    oldpalette.addPaletteListener(this);

                    if(altMin!=null)
                        altMin.setText(format.format(paletteEditor.getXmin()));
                    if(altMax!=null)
                        altMax.setText(format.format(paletteEditor.getXmax()));
                }
            //apply.setEnabled(documentKarto!=null);
            //setPal();
        }


        public void markerAdded(MultiSlider source,int i)
    {}
        public void markerRemoved(MultiSlider source,int i)
        {}
        public void markerMoved(MultiSlider source,int i)
        {}
        public void markerBeginMove(MultiSlider source,int i)
        {}
        public void markerEndMove(MultiSlider source,int i)
        {
            setPal();
        }

        public void colorAdded(InterpolatedPalette source,int i)
        {
            setPal();
        }
        public void colorRemoved(InterpolatedPalette source,int i)
        {
            setPal();
        }
        public void colorChanged(InterpolatedPalette source,int i)
        {
            setPal();
        }
        public void colorMoved(InterpolatedPalette source,int i)
        {}

        protected GridBagLayout gridBagLayout;
        protected GridBagConstraints gridBagConstraints;
        protected JPanel jpanel;

        InterpolatedPalette pal;
        MultiSlider multiSlider;
        JTextField altMin,altMax;
        JButton button;
        PaletteEditor paletteEditor;
        InterpolatedPalette oldpalette;
        Document documentKarto;

        DecimalFormat format;
    }
