/** Boite de dialogue affichant la progression de l'interpolation et permettant de l'interrompre
 * 
 * @author HEIT Sylvestre & Coustillac Laurent
 *
 *
 * Programme kartoMNT : gnration de MNT  partir d'une carte de lignes de niveaux
 * Copyright (C) 2002  HEIT Sylvestre & Coustillac Laurent
 * 
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence
 *Publique Gnrale GNU publie par la Free Software Foundation (version 2).
 *
 *Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
 *y compris les garanties de commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
 *Licence Publique Gnrale GNU pour plus de dtails.
 *
 *Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ; si
 *ce n'est pas le cas, crivez  la
 *Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 */
package kartoMNT;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;


public class ProgressionDialog extends JDialog
    {

        private JProgressBar progressBar;
        private JButton startButton;
        private JTextArea taskOutput;
        private String newline = "\n";
        private LignesDeNiveaux lignesDeNiveaux;

        public ProgressionDialog(Frame parent,LignesDeNiveaux lignes,Thread thread)
        {
            super(parent,true);
            setTitle("Interpolation");
            tempText=new StringBuffer (200);
            lignesDeNiveaux=lignes;
            mythread=thread;

            startButton = new JButton(ResourceManager.get("giveUpKey"));
            startButton.setActionCommand(ResourceManager.get("giveUp"));
            startButton.addActionListener(new ButtonListener());

            taskOutput = new JTextArea(3, 55);
            taskOutput.setMargin(new Insets(2,2,2,2));
            taskOutput.setEditable(false);

            JPanel panel = new JPanel();
            panel.add(startButton);

            JPanel contentPane = new JPanel();
            contentPane.setLayout(new BorderLayout());
            contentPane.add(startButton, BorderLayout.SOUTH);
            panel.setLayout(new BorderLayout());
            panel.add(new JLabel(ResourceManager.get("interpEnCours1")), BorderLayout.NORTH);
            panel.add(new JLabel(ResourceManager.get("interpEnCours2")), BorderLayout.SOUTH);
            panel.setBorder(BorderFactory.createEmptyBorder(2, 2, 2, 2));
            contentPane.add(panel, BorderLayout.NORTH);
            contentPane.add(new JScrollPane(taskOutput), BorderLayout.CENTER);
            setContentPane(contentPane);

            pack();
            Util.centrer(this);
        }

        private Thread mythread;

        synchronized protected void updateSetText()
        {
            taskOutput.setText(tempText.toString());
            taskOutput.setCaretPosition(taskOutput.getDocument().getLength());
            tempText.delete(0,tempText.length());
        }

        /**
          * definit le texte de la boite. 
          *Cette fontion peut tre a partir de n'inporte quel thread
          */
        synchronized void setText(String txt)
        {
            if(tempText.length()>0)
                tempText= tempText.delete(0,tempText.length());
            tempText.append(txt);
            Runnable updateComponent = new Runnable()
                                       {
                                           public void run()
                                           {
                                               updateSetText();
                                           }
                                       };
            SwingUtilities.invokeLater(updateComponent);
        }


        /*synchronized protected void updateText()
        {
            taskOutput.append(tempText.toString());
            taskOutput.setCaretPosition(taskOutput.getDocument().getLength());
            tempText.delete(0,tempText.length());
    }

        // ajoute du texte dans la boite. Cette fontion peut tre a partir de n'importe quel thread

        synchronized void appendText(String txt)
        {
            tempText.append(txt);
            Runnable updateComponent = new Runnable()
                                       {
                                           public void run()
                                           {
                                               updateText();
                                           }
                                       };
            SwingUtilities.invokeLater(updateComponent);
    }*/


        StringBuffer tempText;

        private void termine()
        {
            setVisible(false);
            dispose();
        }

        /**
           *Indique que l'interpolation est termine .
           *Cette fonction a pour effet de fermer la boite de dialogue
           *Cette fontion peut tre a partir de n'inmporte quel thread
          */
        public void taskFinished()
        {
            Runnable fin = new Runnable()
                           {
                               public void run()
                               {
                                   termine();
                               }
                           };
            SwingUtilities.invokeLater(fin);
        }

        /**
         * The actionPerformed method in this class
         * is called when the user presses the start button.
         */
        class ButtonListener implements ActionListener
            {
                public void actionPerformed(ActionEvent evt)
                {
                    lignesDeNiveaux.stopInterpolation();
                    setVisible(false);
                    dispose();
                }
            }


    }
