/** Outil permettant d'ajouter un point de calibration
 * 
 * @author HEIT Sylvestre & Coustillac Laurent
 
 *
 * Programme kartoMNT : gnration de MNT  partir d'une carte de lignes de niveaux
 * Copyright (C) 2002  HEIT Sylvestre & Coustillac Laurent
 * 
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence
 *Publique Gnrale GNU publie par la Free Software Foundation (version 2).
 *
 *Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
 *y compris les garanties de commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
 *Licence Publique Gnrale GNU pour plus de dtails.
 *
 *Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ; si
 *ce n'est pas le cas, crivez  la
 *Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 */
package kartoMNT;

import java.awt.event.*;
import java.awt.*;
import java.awt.Toolkit;


class ToolAddCalibrationPoint implements Tool,MouseListener
    {


        ToolAddCalibrationPoint()
        {
            super();
            cursor=Toolkit.getDefaultToolkit().getImage("icones/croix.gif");
        }


        public void attach(DocumentKarto doc)
        {
            detach();
            if(doc!=null)
                {
                    document=doc;
                    document.getCarteCanvas().addMouseListener(this);
                    //lignesDeNiveauxPanel.addMouseMotionListener(this);
                    Util.setCursor(document.layeredPane,cursor,16,16);
                    //lignesDeNiveauxPanel.getLignesDeNiveaux().setCurrentAltitude(color);
                }

        }

        protected void detach()
        {
            if(document!=null)
                {
                    document.getCarteCanvas().removeMouseListener(this);
                    //lignesDeNiveauxPanel.removeMouseMotionListener(this);
                    Util.removeCursor(document.layeredPane);
                }
        }




        public void mouseClicked(MouseEvent e)
        {}

        public void mouseEntered(MouseEvent e)
        {}

        public void mouseExited(MouseEvent e)
        {}

        public void mousePressed(MouseEvent e)
        {
            ImageCanvas c=document.getCarteCanvas();
            PointCalibrationModel p=new PointCalibrationModel();
            p.setImageCoords(c.canvas2ObjX(e.getX()),c.canvas2ObjY(e.getY()) );
            document.getPointCalibrationSet().add(p);
            document.getPointCalibrationSet().select(p);
        }

        public void mouseReleased(MouseEvent e)
        {}

        protected DocumentKarto document;
        protected Image cursor;
    }

