/** Outil permettant de definir l'altitude de plusieurs lignes de niveau
 * 
 * @author HEIT Sylvestre & Coustillac Laurent
 
 *
 * Programme kartoMNT : gnration de MNT  partir d'une carte de lignes de niveaux
 * Copyright (C) 2002  HEIT Sylvestre & Coustillac Laurent
 * 
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence
 *Publique Gnrale GNU publie par la Free Software Foundation (version 2).
 *
 *Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
 *y compris les garanties de commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
 *Licence Publique Gnrale GNU pour plus de dtails.
 *
 *Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ; si
 *ce n'est pas le cas, crivez  la
 *Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 */
package kartoMNT;

import java.awt.event.*;
import java.awt.*;
import java.awt.Toolkit;


class ToolAltitudeMulti implements Tool,MouseListener,MouseMotionListener
    {


        ToolAltitudeMulti()
        {
            super();

            line=new Line();
            line.setColor(new Color(1.0f,0.0f,0.3f));
            line.setExtremiteFleche(1,12);
            altitudeDialog=null;
        }

        public void setAltitudeDialog(AltitudeDialog d)
        {
            altitudeDialog=d;
        }

        public void attach(DocumentKarto doc)
        {
            detach();
            if(doc!=null)
                {
                    document=doc;
                    lignesDeNiveauxPanel=doc.getFloatDataViewer();
                    lignesDeNiveauxPanel.addMouseListener(this);
                    lignesDeNiveauxPanel.addMouseMotionListener(this);

                    Util.removeCursor(document.layeredPane);

                }
        }

        protected void detach()
        {
            if(lignesDeNiveauxPanel!=null)
                {
                    lignesDeNiveauxPanel.removeMouseListener(this);
                    lignesDeNiveauxPanel.removeMouseMotionListener(this);

                }
            if(document!=null)
                {
                    document.removeObject(line);
                }
        }

        public Line getLine()
        {
            if(document!=null)
                {
                    if(document.containsObject(line))
                        {
                            return line;
                        }
                }
            return null;
        }


        public void mouseClicked(MouseEvent e)
        {}

        public void mouseEntered(MouseEvent e)
        {}

        public void mouseExited(MouseEvent e)
        {}

        public void mousePressed(MouseEvent e)
        {

            document.removeObject(line);
            document.addObject(1000,line);
            line.drawPanelCoords(lastx=e.getX(),lasty=e.getY(),e.getX(),e.getY());
        }

        public void mouseReleased(MouseEvent e)
        {}


        public void mouseMoved(MouseEvent e)
        {}


        public void mouseDragged(MouseEvent e)
        {
            line.drawPanelCoords(lastx,lasty,e.getX(),e.getY());
        }


        protected FloatDataViewer lignesDeNiveauxPanel;


        protected Image cursor;
        protected DocumentKarto document;

        Line line;
        AltitudeDialog altitudeDialog;
        int lastx,lasty;
    }

