/** classe de base des outils de trac contenant des fontions communes  ces outils
 * 
 * @author HEIT Sylvestre & Coustillac Laurent
  *
 * Programme kartoMNT : gnration de MNT  partir d'une carte de lignes de niveaux
 * Copyright (C) 2002  HEIT Sylvestre & Coustillac Laurent
 * 
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence
 *Publique Gnrale GNU publie par la Free Software Foundation (version 2).
 *
 *Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
 *y compris les garanties de commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
 *Licence Publique Gnrale GNU pour plus de dtails.
 *
 *Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ; si
 *ce n'est pas le cas, crivez  la
 *Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 */
package kartoMNT;


import javax.swing.*;
import java.awt.*;

class ToolGenericDraw implements Tool
    {
    	
    	
        protected FloatDataViewer lignesDeNiveauxPanel;
        protected LignesDeNiveaux lignesDeNiveaux;
        protected DocumentKarto document;

        protected Brush currentBrush;
        
        
        ToolGenericDraw()
        {
            currentBrush=new Brush();
        }

        public void attach(DocumentKarto doc)
        {
            detach();
            if(doc!=null)
                {
                    document=doc;
                    lignesDeNiveauxPanel=doc.getFloatDataViewer();
                    lignesDeNiveaux=doc.getLignesDeNiveaux();
                    out=true;
                }

        }

        protected void detach()
        {}



        public float getValue(Brush brush,int x,int y)
        {
            int xx,yy,i;
            xx=(int)lignesDeNiveauxPanel.canvas2ObjX(x);
            yy=(int)lignesDeNiveauxPanel.canvas2ObjY(y);
            float alt=LignesDeNiveaux.LINE_WITH_NO_ALTITUDE;
            float v;
            for(i=0;i<brush.pinceauX.length;i++)
                {
                    v=lignesDeNiveaux.getValueData(xx+brush.pinceauX[i],yy+brush.pinceauY[i]);
                    if((v!=LignesDeNiveaux.EMPTY) && (v!=LignesDeNiveaux.LINE_WITH_NO_ALTITUDE))
                        {
                            if(alt==LignesDeNiveaux.LINE_WITH_NO_ALTITUDE)
                                {
                                    alt=v;
                                }
                            else if(v!=alt)
                                {
                                    return LignesDeNiveaux.LINE_WITH_NO_ALTITUDE;
                                }
                        }
                }
            return alt;
        }

        // On met l'altitude pour tout les point qui sont dans le pinceau courant
        // cela vite d'etre oblig de faire une selection au pixel pres
        public void setAltitude(Brush brush,int x,int y,float alt)
        {
            int xx,yy,i;
            xx=(int)lignesDeNiveauxPanel.canvas2ObjX(x);
            yy=(int)lignesDeNiveauxPanel.canvas2ObjY(y);
            for(i=0;i<brush.pinceauX.length;i++)
                {
                    lignesDeNiveaux.setAltitude2(xx+brush.pinceauX[i],yy+brush.pinceauY[i],alt,false);
                }
            lignesDeNiveaux.notifyRegionChanged();
        }

		/** retourn l'altitude d'un point donn sur la carte
		*/
		public float getAltitude(int x, int y){
			return lignesDeNiveaux.getAltitude(x,y);
		}
		
        public void setBrush(Brush b)
        {
            currentBrush=b;
            if(lignesDeNiveauxPanel!=null)
                {
                    lignesDeNiveauxPanel.setBrush(b);
                }
            if(lignesDeNiveauxPanel!=null)
                {
                    lignesDeNiveaux.setBrush(currentBrush);
                }
        }

        private boolean out;

        void updateCursor(JPanel lignesDeNiveauxPanel,int x,int y,Image cursor,int CenterCursorX,int CenterCursorY)
        {
            Dimension dim=lignesDeNiveauxPanel.getSize();
            boolean b=(x>=dim.width) || (y>=dim.height);
            if(b &&(!out))
                {
                    out=true;
                    Util.removeCursor(document.layeredPane);
                }

            if(!b &&(out))
                {
                    out=false;
                    Util.setCursor(document.layeredPane,cursor,CenterCursorX,CenterCursorY);
                }
        }


    }
