/**************************************************************************
*   vthierry@sophia.inria.fr, Copyright (C) 1996.  All rights reserved.   *
**************************************************************************/

package kartoMNT.duck.awt;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import java.net.*;
import java.lang.reflect.*;

/** This class encapsulates the reference to the Duck Awt patches: DO NOT USE !
 */

public class DuckAwt {

    // Public reference to the main frame
    /*!*/ public static Frame frame = null;
    // Relative positionning of popup windows
    private static int dx, dy;
    
    // Public reference to the calling applet
    /*!*/ public static Applet applet = null;

    /*** Validate all windows attached to this frame ... */

    static Vector windows = new Vector();

    /*!*/ public static void open(Window window) {
	if ((frame == null) && (window instanceof Frame)) {
	    frame = (Frame) window;
	    dx = 0; dy = 0;
	}
	windows.addElement(window);
	window.pack();
	window.setSize(window.getPreferredSize());
	// Here we hardwire windows locations to avoid spurious effects
	if ((frame != null) && (window != frame)) {
	    dx += 10; dy += 10;
	    window.setLocation(frame.getLocation().x + dx,
			       frame.getLocation().y + dy);
	} else {
	    Dimension dimension = Toolkit.getDefaultToolkit().getScreenSize();
	    window.setLocation(dimension.width/2-window.getSize().width/2,
			       dimension.height/2-window.getSize().height/2);
	}
	window.setVisible(true);
	window.requestFocus();
	validate();
    }
    /*!*/ public static void close(Window window) {
	if (window == frame)
	    frame = null;
	windows.removeElement(window);
	window.dispose();
    }
    /*!*/ public static void validate() {
	// Thread.yield();
	for(Enumeration w = windows.elements(); w.hasMoreElements();) {
	    Container window = (Container) w.nextElement();
	    // This is a dilemma : either we stick the location and update
	    //  may be very long ... or windows wander on the screen !
	    // Point location = window.getLocation();
	    window.setSize(window.getPreferredSize());
	    window.validate();
	    // window.setLocation(location);
	}
	// Thread.yield();
    }

    /*!*/ public static void register(Applet applet) {
	DuckAwt.applet = applet;
    }

    /*** Return the URL of a given name in the present context */

    /*!*/ public static URL url(String urlName) {
	URL context = (applet == null) ? null : applet.getDocumentBase(), url;
	try {
	    url = new URL(context, urlName);
	} catch (Exception e1) {
	    try {
		url = new URL(context, "file:/" + urlName);
	    } catch (Exception e2) {
		url = null;
	    }
	}
	return url;
    }
}
