/** Matrice de projection. 
	Calibration avec n points aux moindre carrs 
Etape suivante : rejection d'outliers...
 * @version 0.7
 * @author FERNANDES Gilbert & GASPARD Francois 
 * module Proj.java Version 0.7 du 
 *
 * Programme karto : cartographie 2D sur cartes numriques
 * Copyright (C) 2000 FERNANDES Gilbert & GASPARD Francois mail : karto@free.fr
 * 
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence 
   Publique Gnrale GNU publie par la Free Software Foundation (version 2 ou bien toute autre version 
   ultrieure choisie par vous).

   Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite, 
   y compris les garanties de commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la 
   Licence Publique Gnrale GNU pour plus de dtails.

   Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ; si 
   ce n'est pas le cas, crivez  la 
   Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis. 
*/

package kartoMNT.karto.math;

import java.awt.*;
import java.awt.geom.*;
import java.util.Vector;
import kartoMNT.duck.math.*;
import kartoMNT.ResourceManager;

public class Proj{
	double proj[]; // Modele affine
    public double[] getProj() {return proj;}
	double projInv[];// donc inverse == affine si det(proj)!=0
	// sinon y fera une division par 0 et gueulera...
    public double[] getProjInv() {return projInv;}
	double coeffZoom=1;
	/** matrice de projection pour effectuer le zoom en cours sur la carte ( zoom + trenslation) */
	double m_MatZoom[];
	
	public String toString(){
		return new String(ResourceManager.get("projMatrix")+" :\n"+proj[0]+" "+proj[1]+" "+proj[2]+proj[3]+" "+proj[4]+" "+proj[5]+"0 0 1");
	}

	public Proj(Point2D P[], Point2D p[]) throws Exception {
		proj = new double[6];
		projInv = new double[6];
		m_MatZoom = new double[6];
		// initialiser avec la matrice I
		m_MatZoom[0]=1;
		m_MatZoom[4]=1;
		
		System.out.println("Class Proj v1.3");
		
		if ((P.length !=p.length) || (P.length <3))
			throw new Exception(ResourceManager.get("badData"));
		
		if (P.length == 3){
			try{
			// modif Gilbert : la division par 0 ne leve plus d'exception !!!
				System.out.println("Calibration sur 3 points");
				double diviseur =(-P[2].getY()*P[0].getX()+P[2].getY()*P[1].getX()-P[0].getY()*P[1].getX()+P[1].getY()*P[0].getX()+P[0].getY()*P[2].getX()-P[1].getY()*P[2].getX());

				if (Math.abs(diviseur) < 0.0001)
					throw new Exception(ResourceManager.get("div0"));
				proj[0] =(float)( (-P[1].getY()*p[2].getX()-P[0].getY()*p[1].getX()+P[2].getY()*p[1].getX()+P[1].getY()*p[0].getX()+P[0].getY()*p[2].getX()-P[2].getY()*p[0].getX())/diviseur);
				
				proj[1] = (float)(-(-P[1].getX()*p[2].getX()+P[2].getX()*p[1].getX()+P[1].getX()*p[0].getX()-P[0].getX()*p[1].getX()+P[0].getX()*p[2].getX()-P[2].getX()*p[0].getX())/diviseur);

				proj[2] = (float)((P[2].getX()*P[0].getY()*p[1].getX()-P[1].getX()*P[0].getY()*p[2].getX()+P[1].getY()*P[0].getX()*p[2].getX()+P[2].getY()*P[1].getX()*p[0].getX()-P[2].getY()*P[0].getX()*p[1].getX()-P[1].getY()*P[2].getX()*p[0].getX())/diviseur);

				proj[3] =(float)( -1/diviseur*(P[1].getY()*p[2].getY()-P[0].getY()*p[2].getY()-P[2].getY()*p[1].getY()-P[1].getY()*p[0].getY()+P[0].getY()*p[1].getY()+P[2].getY()*p[0].getY()));

				proj[4] = (float)((P[1].getX()*p[2].getY()-P[1].getX()*p[0].getY()+P[0].getX()*p[1].getY()-P[0].getX()*p[2].getY()+P[2].getX()*p[0].getY()-P[2].getX()*p[1].getY())/diviseur);

				proj[5] = (float)(-(P[2].getY()*P[0].getX()*p[1].getY()-P[2].getY()*P[1].getX()*p[0].getY()+P[1].getY()*P[2].getX()*p[0].getY()-P[1].getY()*P[0].getX()*p[2].getY()+P[1].getX()*P[0].getY()*p[2].getY()-P[2].getX()*P[0].getY()*p[1].getY())/diviseur);

			} catch(Exception e){
				//MsgInfo erW = new MsgInfo(parent, MsgInfo.ERROR,"Verifiez que les points ne sont pas alignes  !");
				throw new Exception(ResourceManager.get("checkPts"));
				//throw e;
			}
		} else{
			try{
				System.out.println("Calibration sur "+P.length+" points");
				int n = P.length;
				int nc = 6;
				System.out.println(n);
				double A[] = new double[2*n*6];
				double b[] = new double[2*n];
				for(int i = 0; i < n; i++){
					b[2*i] = p[i].getX();
					b[2*i+1] = p[i].getY();
					A[0+2*i*nc] = P[i].getX();
					A[1+2*i*nc] = P[i].getY();
					A[2+2*i*nc] = 1.0;				
					A[3+(2*i+1)*nc] = P[i].getX();
					A[4+(2*i+1)*nc] = P[i].getY();
					A[5+(2*i+1)*nc] = 1.0;
				} 
				proj = LocalSolve.leastsquare( A , b , 2*n  , nc );  
	
				System.out.println(ResourceManager.get("projMatrix")+"\n"+proj[0]+" "+proj[1]+" "+proj[2]+" ");
				System.out.println(proj[3]+" "+proj[4]+" "+proj[5]+" ");
			}
			catch(Exception e){
				System.out.println(e);
				//MsgInfo erW = new MsgInfo(parent, MsgInfo.ERROR,"Verifiez que les points ne sont pas alignes  !");		
                throw new Exception(ResourceManager.get("checkPts"));
			}
		}
		try{
			/* calcul de la matrice inverse */
			/* A modifier : preferer un mc en inversant les pts : 
			   plus stable */
			double diviseur = (-proj[0]*proj[4]+proj[3]*proj[1]);
//			System.out.println("diviseur inverse : "+diviseur);
			if (Math.abs(diviseur) < 0.0001)
					throw new Exception(ResourceManager.get("div0"));
			projInv[0] = -proj[4]/diviseur;
			projInv[1] = proj[1]/diviseur;
			projInv[2] = -(proj[1]*proj[5]-proj[2]*proj[4])/diviseur;
			projInv[3] = proj[3]/diviseur;
			projInv[4] = -proj[0]/diviseur;
			projInv[5] = (proj[0]*proj[5]-proj[2]*proj[3])/diviseur;
		} catch(Exception e){
            throw new Exception(ResourceManager.get("checkPts"));
			/*MsgInfo erW = new MsgInfo(parent, MsgInfo.ERROR,"Impossible d'inverser la calibration !");
			throw e;*/
		}
	//	System.out.println("Matrice inverse "+projInv[0]+" "+projInv[1]+" "+projInv[2]+" ");
	//	System.out.println("                "+projInv[3]+" "+projInv[4]+" "+projInv[5]+" ");    
	}
	
	/** projection des coordonnes terrain (3D) sur l'image de la carte
	 * @param p : coordonnes X,Y du terrain
	 * @return : les coordonnes x,y du point projet sur la carte */
	public Point project(Point p){
		double x,y;
		x = proj[0]* p.x+proj[1]*p.y + proj[2];
		y = proj[3]*p.x+proj[4]*p.y+proj[5];
		// appliquer la transformation m_MatZoom
		return new Point((int)(m_MatZoom[0]*x+m_MatZoom[2]),
						(int)( m_MatZoom[4]*y+m_MatZoom[5]));
	}

	/** projection des coordonnes terrain (3D) sur l'image de la carte
	 * @param vx : coordonne X du terrain
	 * @param vy : coordonne Y du terrain
	 * @return : les coordonnes x,y du point projet sur la carte */
	public Point project(double vx, double vy){
		double x,y;
		x = proj[0]* vx+proj[1]*vy + proj[2];
		y = proj[3]*vx+proj[4]*vy+proj[5];
		// appliquer la transformation m_MatZoom
		return new Point((int)(m_MatZoom[0]*x+m_MatZoom[2]),
						(int)( m_MatZoom[4]*y+m_MatZoom[5]));
	}
	/** renvoie les coordonnes terrain d'un point cliqu sur l'image
	 *  @param p : coordonne d'un point sur l'image
	 *  @return : les coordonnes X,Y de ce meme point sur le terrain 
	*/
	public Point2D.Double pixels2Lambert(Point p){
		double x,y;
		// appliquer la transformation inverse de m_MatZoom
		x = (p.x -m_MatZoom[2])/m_MatZoom[0];
		y = (p.y -m_MatZoom[5])/m_MatZoom[4];
		return new Point2D.Double(projInv[0]* x+projInv[1]*y + projInv[2],
									 projInv[3]*x+projInv[4]*y +projInv[5]);
	}
	/** renvoie les coordonnes terrain d'un point cliqu sur l'image
	 *  @param p : coordonne d'un point sur l'image
	 *  @return : les coordonnes X,Y de ce meme point sur le terrain 
	*/
	public Point2D.Double pixels2Lambert(Point2D p){
		double x,y;
		x = (p.getX() -m_MatZoom[2])/m_MatZoom[0];
		y = (p.getY() -m_MatZoom[5])/m_MatZoom[4];
		return new Point2D.Double(projInv[0]* x+projInv[1]*y  + projInv[2],
									projInv[3]*x+projInv[4]*y +projInv[5]);
	}	
	/** renvoie les coordonnes terrain d'un point cliqu sur l'image
	 *  @param px : coordonne x d'un point sur l'image
   	 *  @param py : coordonne y d'un point sur l'image
	 *  @return : les coordonnes X,Y de ce meme point sur le terrain 
	*/
    public Point2D.Double pixels2Lambert(double px,double py){
		double x,y;
		x = (px -m_MatZoom[2])/m_MatZoom[0];
		y = (py -m_MatZoom[5])/m_MatZoom[4];
		return new Point2D.Double(projInv[0]* x+projInv[1]*y  + projInv[2],
									projInv[3]*x+projInv[4]*y +projInv[5]);
	}	
    /** projection des coordonnes terrain (3D) sur l'image de la carte
	 * @param x : coordonne X du terrain
	 * @param y : coordonne Y du terrain
	 * @return : la coordonne x du point projet sur la carte */
	public double projX(double x, double y){
		double newx=proj[0]* x+proj[1]*y + proj[2];
		// appliquer la transformation m_MatZoom
		return (m_MatZoom[0]*newx+m_MatZoom[2]);
	}
	/** projection des coordonnes terrain (3D) sur l'image de la carte
	 * @param x : coordonne X du terrain
	 * @param y : coordonne Y du terrain
	 * @return : la coordonne y du point projet sur la carte */
	public double projY(double x, double y){
		double newy=proj[3]* x+proj[4]*y + proj[5];
		// appliquer la transformation m_MatZoom
		return (m_MatZoom[4]*newy+m_MatZoom[5]);
	}
	/** suprime le zoom ou le dplacement dans l'image pour revenir a la carte d'origine (celle
	 *  qui a t calibre 
	*/
	public void removeZoomMatrix(){
		m_MatZoom = new double[6];
		// initialiser avec la matrice I
		m_MatZoom[0]=1;
		m_MatZoom[4]=1;
	}
	/** modifie le coeff du zoom de la carte 
	*/
	public void changeCoeffZoom(double newCoeff){
		m_MatZoom[0]= m_MatZoom[0]*newCoeff;
		m_MatZoom[2]= m_MatZoom[2]*newCoeff;
		m_MatZoom[4]= m_MatZoom[4]*newCoeff;
		m_MatZoom[5]= m_MatZoom[5]*newCoeff;
	}
	/** ajoute un dplacement du coin de la carte pour la fenetre de zoom */
	public void addTranslation(int x, int y){
		m_MatZoom[2]= m_MatZoom[2]-x;
		m_MatZoom[5]= m_MatZoom[5]-y;
	}
	/** indique si un zoom est en cours sur la carte*/
	public boolean isZoom(){
		return( (m_MatZoom[0]!=1)||(m_MatZoom[4]!=1)||(m_MatZoom[2]!=0)||(m_MatZoom[5]!=0));
	}
}
