/** Affiche les diffrents messages de l'application 
 * @version 0.6 
 * @author FERNANDES Gilbert & GASPARD Francois 
 * module Carroyage.java Version 0.6 du 
 *
 * Programme karto : cartographie 2D sur cartes numriques
 * Copyright (C) 2000 FERNANDES Gilbert & GASPARD Francois mail : karto@free.fr
 * 
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence
   Publique Gnrale GNU publie par la Free Software Foundation (version 2 ou bien toute autre version
   ultrieure choisie par vous).

   Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
   y compris les garanties de commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
   Licence Publique Gnrale GNU pour plus de dtails.

   Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ; si
   ce n'est pas le cas, crivez  la
   Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
*/
package kartoMNT.karto.outils;

import java.awt.*;
import java.awt.Event.*;
import java.awt.event.*;
import kartoMNT.duck.awt.*;
import kartoMNT.ResourceManager;


public class MsgInfo implements ActionListener{
	/* types de messages d'erreur */
	public static final int INFO=1; 	/** message d'infromation simple */
	public static final int WARN=2;		/** message de Warning */
	public static final int ERROR=3;	/** message d'erreur ( grave ) */

	/* type de rponse possible par l'utilisateur. par dfaut toujours OK */
	public static final int OK=1;
	public static final int OUI=2;
	public static final int NON=4;
	public static final int CANCEL=8;

	protected int m_reponse ;		/** rponse de l'oprateur sur les boutons disponible */
	private Dialog m_fen;		/** fenetre de la boite de dialogue */
	Point m_parentPos = new Point();	/** position dans l'cran de la fenetre parent */
	Button i_btOK	 = new Button(ResourceManager.get("OkKey"));
	Button i_btOui	= new Button(ResourceManager.get("yesKey"));
	Button i_btNon	= new Button(ResourceManager.get("noKey"));
	Button i_btCancel = new Button(ResourceManager.get("giveUpKey"));
	protected int m_typRep;

/************************************************************************************************/
/* Constructeurs														*/
/************************************************************************************************/
	/** constructeur
	 * @param parent : fenetre parent ayant demand l'affichage de la dialogue
	 * @param typMsg : type de message demand ( INFO, WARN, ERROR )
	 * @param msg : texte du message
	 * @param msg2 : seconde ligne de message (null si une seule ligne )
	 * @param p : position en pixel dans la fenetre pere ou positionner la fenetre ( le coin en haut a gauche )
	*/
	public MsgInfo(Frame parent, int typMsg, int typRep, String msg, String msg2, Point p){
		m_fen = new Dialog(parent, true);
		GridPanel pan = new GridPanel(1);
		Panel boutons = new Panel();

		switch(typMsg){
			case INFO: m_fen.setTitle(ResourceManager.get("info"));
					break;
			case WARN: m_fen.setTitle(ResourceManager.get("warning"));
					break;
			case ERROR: m_fen.setTitle(ResourceManager.get("error"));
					break;
			default: m_fen.setTitle("Message type "+typMsg);
		}
		this.m_typRep = typRep;
		i_btOK.addActionListener(this);
		i_btOui.addActionListener(this);
		i_btNon.addActionListener(this);
		i_btCancel.addActionListener(this);
		boutons.setLayout(new FlowLayout());
		pan.add( new LabelPanel(""));
		pan.add( new LabelPanel(msg));
		if (!msg2.equals(""))
			pan.add( new LabelPanel(msg2));
		pan.add( new LabelPanel(""));
		if (((m_typRep & OK) !=0 ) || (m_typRep ==0))
			boutons.add(i_btOK);
		if ((m_typRep & OUI) !=0 )
			boutons.add( i_btOui);
		if ((m_typRep & NON) !=0 )
			boutons.add( i_btNon);
		if ((m_typRep & CANCEL) !=0 ){
			i_btCancel.addKeyListener(new MySpy());
			boutons.add( i_btCancel);
		}
		if (m_typRep == OK)
			i_btOK.addKeyListener(new MySpy());
		pan.add(boutons);
		m_fen.add(pan);
		m_fen.pack();

                Dimension d;
         if(parent!=null)
        {m_parentPos = parent.getLocationOnScreen();
		d = parent.getSize();
		}
        else
        {m_parentPos=new Point(0,0);
        d = m_fen.getToolkit().getScreenSize();
        }

    if (p.x == 0 && p.y == 0)
        { p.x = d.width/2;
 		 p.y = d.height/2;
        }
        
        //m_fen.setLocation(p.x+m_parentPos.x, p.y+m_parentPos.y);
		m_fen.setModal(true);

        d = m_fen.getSize();
        //System.out.println("x="+d.width+"  y="+d.height);
        m_fen.setLocation(p.x+m_parentPos.x-d.width/2, p.y+m_parentPos.y-d.height/2);

		m_fen.setVisible(true);
		m_fen.requestFocus();
	}

	public MsgInfo(Frame parent, int typMsg, int typRep, String msg, Point p){
		this(parent, typMsg, typRep, msg, "",p);
	}
	public MsgInfo(Frame parent, int typMsg, int typRep, String msg){
		this(parent, typMsg, typRep, msg, "", new Point(0,0));
	}
	public MsgInfo(Frame parent, int typMsg, String msg){
		this(parent, typMsg, OK, msg, "", new Point(0,0));
	}
	public MsgInfo(Frame parent, int typMsg, String msg, String msg2){
		this(parent, typMsg, OK, msg, msg2, new Point(0,0));
	}
	/** constructeur, affiche une fenetre d'info avec plusieurs lignes de textes, sans saisie de choix
	 * ( seulement OK )
	 * @param parent : fenetre parent ayant demand l'affichage de la dialogue
	 * @param title : titre dans la barre de la fenetre
	 * @param msg : texte du message sur plusieurs ligne
	*/
	public MsgInfo(Frame parent, String titre,String msg[]){
		m_fen = new Dialog(parent, true);
		GridPanel pan = new GridPanel(1);
		Panel boutons = new Panel();
		m_fen.setTitle(titre);

		i_btOK.addActionListener(this);
		boutons.setLayout(new FlowLayout());
		pan.add( new LabelPanel(""));
		int i;
		for (i = 0; i < msg.length; i++) {
			pan.add( new LabelPanel(msg[i]));
		}
		pan.add( new LabelPanel(""));
		boutons.add(i_btOK);
		pan.add(boutons);
		m_fen.add(pan);
		m_fen.pack();

        Dimension d;
         if(parent!=null)
        {m_parentPos = parent.getLocationOnScreen();
		d = parent.getSize();
        }
        else
        {d = m_fen.getToolkit().getScreenSize();
        m_parentPos=new Point(0,0);
        }

		//m_fen.setLocation(d.width/2+m_parentPos.x, d.height/2+m_parentPos.y);
		m_fen.setModal(true);

        d = m_fen.getSize();
        //System.out.println("x="+d.width+"  y="+d.height);
        m_fen.setLocation(d.width/2+m_parentPos.x-d.width/2, d.height/2+m_parentPos.y-d.height/2);

		m_fen.setVisible(true);
		m_fen.requestFocus();
	}
	/** evenement utilis pour la gestion des cliques sur les boutons */
	class MySpy implements KeyListener{
		public void keyTyped(KeyEvent e){}
		public void keyPressed(KeyEvent e){
			if (e.getKeyCode()==KeyEvent.VK_ENTER){
				if (m_typRep == OK)
				actionPerformed(new ActionEvent((Object)i_btOK,ActionEvent.ACTION_FIRST,ResourceManager.get("OkKey")));
			else
			 	actionPerformed(new ActionEvent((Object)i_btCancel,ActionEvent.ACTION_FIRST,ResourceManager.get("giveUpKey")));
			}
		}
		public void keyReleased(KeyEvent e){}
	}

/************************************************************************************************/
/* Autres mthodes													*/
/************************************************************************************************/
	/** gestion des vnements pour les cliques sur les boutons */
	public void actionPerformed(ActionEvent e){
		int rep=0;
		if(e.getActionCommand()==ResourceManager.get("OkKey")){
			m_fen.setVisible(false);
			rep=OK;
		}
		else if(e.getActionCommand()==ResourceManager.get("yesKey")){
			m_fen.setVisible(false);
			rep=OUI;
		}
		else if(e.getActionCommand()==ResourceManager.get("noKey")){
			m_fen.setVisible(false);
			rep=NON;
		}
		else if(e.getActionCommand()==ResourceManager.get("giveUpKey")){
			m_fen.setVisible(false);
			rep=CANCEL;
		}
		if (rep > 0) {
			m_fen.dispose();
			m_reponse = rep;
		}
	}
	/** renvoie la rponse a la question */
	public int reponse(){
		return m_reponse;
	}
}




