package kartoMNT.visu3d;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.plaf.basic.*;
import java.io.*;

import kartoMNT.*;

/**
   Dialogue de Bouchage des Trous dans la texture due  la calibration
*/
public class BoucheTrouDialog extends JDialog implements ItemListener, ActionListener{
    /** Couleur bouche-trou */
    private Color couleurBC=Variables.boucheTrouCouleur;
    /** Nom du fichier de la texture servant  boucher les trous */
    private String nomFichier=Variables.boucheTrouTexture;

    /** radio bouton de la Couleur */
    private JRadioButton rbCouleur;
    /** radio bouton de choix du fichier de texture */
    private JRadioButton rbFichier;

    /** JTextField de "Fichier" (Texture bouche trou) */
    private JTextField nomFichier1;
    /** bouton "..." (Texture bouche trou ) */
    private JButton choixFichier1;
    /** bouton ok */
    private JButton ok;
    /** bouton sauver */
    private JButton sauver;
    /** Bouton de choix de la couleur */
    private JButton bCouleur;

    /** L'utilisateur a-t-il correctement rentr ses paramtres et appuy sur OK ? */
    private boolean isOk=false;

    /** JFileChooser d'images */
    private JFileChooser fcImage= new JFileChooser(Options.getDirRead());

    /**
       Constructeur
    */
    public BoucheTrouDialog(){
	super((JFrame)null,ResourceManager.get("titleVisu"));

	fcImage.setFileSelectionMode(JFileChooser.FILES_ONLY);

	ExampleFileFilter filterImg = new ExampleFileFilter();
	filterImg.addExtension("jpg");
	filterImg.addExtension("gif");
	filterImg.setDescription(ResourceManager.get("images"));
	fcImage.addChoosableFileFilter(filterImg);

	// Construction de l'Interface
	Container contentPane=getContentPane();
	contentPane.setLayout(new BorderLayout());
	
	// Panel Texte
	JPanel panelTexte = new JPanel();
	panelTexte.setLayout(new BorderLayout());

	TitledBorder title0 = BorderFactory.createTitledBorder(ResourceManager.get("warning"));
	panelTexte.setBorder(title0);

	JTextArea texte=new JTextArea(ResourceManager.get("boucheTrou"),4,55);	
	texte.setFont(Font.decode("Arial-BOLD-14"));
	texte.setEditable(false);
	panelTexte.add(texte,BorderLayout.NORTH);
	//panelTexte.add((new BasicOptionPaneUI()).getIconForType(JOptionPane.WARNING_MESSAGE),BorderLayout.WEST);
	
	// Panel Bouche Trou
	JPanel panelBC = new JPanel();
	panelBC.setLayout(new GridLayout(3,1));

	TitledBorder title1 = BorderFactory.createTitledBorder(ResourceManager.get("titleboucheTrou"));
	panelBC.setBorder(title1);

	JPanel panelCouleur=new JPanel(new FlowLayout(FlowLayout.LEFT));

	rbCouleur = new JRadioButton(ResourceManager.get("color"),Variables.bTCS);	
	rbCouleur.addItemListener(this);
	panelCouleur.add(rbCouleur);

	bCouleur=new JButton();
	bCouleur.setBackground(couleurBC);
	bCouleur.setPreferredSize(new Dimension(40,40));
	bCouleur.addActionListener(this);
	panelCouleur.add(bCouleur);

	// panel Fichier
	JPanel panelFichier = new JPanel();
	panelFichier.setLayout(new GridLayout(2,1));

	rbFichier = new JRadioButton(ResourceManager.get("file"),!Variables.bTCS);
	rbFichier.addItemListener(this);
	panelFichier.add(rbFichier);

	JPanel panelFichier1=new JPanel();
	panelFichier1.setLayout(new FlowLayout(FlowLayout.LEFT));
	JPanel panelVide =new JPanel();
	panelVide.setPreferredSize(new Dimension(20,10));
	nomFichier1 = new JTextField(20);
	nomFichier1.setText(nomFichier);
		
	nomFichier1.setEditable(!Variables.bTCS);
		
	choixFichier1 = new JButton("...");
	choixFichier1.addActionListener(this);
	panelFichier1.add(panelVide);
	panelFichier1.add(nomFichier1);
	panelFichier1.add(choixFichier1);
	panelFichier.add(panelFichier1);

	ButtonGroup rg1 = new ButtonGroup();	
	rg1.add(rbCouleur);
	rg1.add(rbFichier);

	JPanel panelBoutons=new JPanel(new FlowLayout());

	ok = new JButton(ResourceManager.get("OkKey"));
	ok.addActionListener(this);
	panelBoutons.add(ok);

	sauver = new JButton(ResourceManager.get("save"));
	sauver.addActionListener(this);
	panelBoutons.add(sauver);
	

	panelBC.add(panelCouleur);
	panelBC.add(panelFichier);

	contentPane.add(panelTexte,BorderLayout.NORTH);
	contentPane.add(panelBC,BorderLayout.CENTER);
	contentPane.add(panelBoutons,BorderLayout.SOUTH);

	addWindowListener(new WindowAdapter(){
		public void windowClosing(WindowEvent e) {
		    isOk=true;
		} 
		
	    });
	setSize(350,400);
	setResizable(false);

	// positionnement du dialog
	Toolkit tk=Toolkit.getDefaultToolkit();
	Dimension d1=tk.getScreenSize();
	Dimension d2=getSize();
	setLocation((int)Math.max((d1.getWidth()-d2.getWidth())/2,0),(int)Math.max((d1.getHeight()-d2.getHeight())/2,0));
		
	setVisible(true);
    }

    /**
       Accesseur de isOK
       @return isOk
    */
    public boolean isGood(){
	return isOk;
    }


    /**
     *	Ecouteurs des Radio Boutons
     *	@param ie vnement engendr lors de l'appui sur un Radio Bouton
     **/
    public void itemStateChanged(ItemEvent ie){
	if (ie.getSource() == rbCouleur){
	    nomFichier1.setEditable(false);			
	}
	else if (ie.getSource() == rbFichier){
	    nomFichier1.setEditable(true);			
	}
    }

    /**
       L'utilisateur a-t-il choisi la couleur ou la texture ?
       @return true si Couleur, false si Texture
    */
    public boolean choiceIsColor(){
	return rbCouleur.isSelected();
    }

    /**
       Accesseur de la couleur Bouche-Trou
       @return couleurBC
    */
    public Color getCouleurBC(){
	return couleurBC;
    }

    /**
       Accesseur du nom de fichier de texture
       @return nomFichier
    */
    public String getNomFichier(){
	return nomFichier;
    }

    /**
	 * Mthode appel quand on appuie sur un bouton
	 *
	 * @param ae L'ActionEvent appel quand quelqu'un 
	 *           appuie sur un bouton
	 */
	public void actionPerformed(ActionEvent ae){
		JButton bouton = (JButton)ae.getSource();

		// si l'utilisateur appuie sur OK
		if (bouton==ok){
		    // si l'utilisateur a choisi la texture
		    if (rbFichier.isSelected()){
			// on vrifie que le fichier slectionn est correct
			File file = null;
			try{
			    file = new File(nomFichier1.getText());	
			}catch(Exception e){
			    file = new File("");	
			}
			
			if (file.exists()){
			    if (!file.canRead()){
				JOptionPane.showMessageDialog(null,ResourceManager.get("errorTexRead"),ResourceManager.get("error"),JOptionPane.WARNING_MESSAGE);
				return;
			    }
			}
			else{
			    JOptionPane.showMessageDialog(null,ResourceManager.get("errorTexNotExist"),ResourceManager.get("error"),JOptionPane.WARNING_MESSAGE);
			    return;
			}
		    }

		    isOk=true;
		    setVisible(false);		    
		}
		// si l'utilisateur a appuy sur enregistrer
		else if (bouton==sauver){
		    // ...on sauvegarde...
		    Variables.setVariable("boucheTrouCouleur",Integer.toString(couleurBC.getRGB()));
		    Variables.setVariable("boucheTrouTexture",nomFichier);
		    Variables.setVariable("bTCS",(new Boolean(rbCouleur.isSelected())).toString());
		}
		// si l'utilisateur a appuy sur le radio bouton de couleur
		else if (bouton==bCouleur){
		    Color newColor = JColorChooser.showDialog(
                                   this,
                                   ResourceManager.get("chooseColor"),
                                   couleurBC);

		    if (newColor!=null) couleurBC=newColor;

		    bCouleur.setBackground(couleurBC);
		}
		// bouton "..." (de texture Bouche trou du MNT)
		else if (bouton == choixFichier1){
			if (nomFichier1.isEditable()){
								
				int returnVal = fcImage.showOpenDialog(null);
				
				if (returnVal==JFileChooser.APPROVE_OPTION){
				    File file=fcImage.getSelectedFile();
					// on vrifie si le fichier est accessible
				    if (file.exists()){
						if (!file.canRead()){
						    JOptionPane.showMessageDialog(null,ResourceManager.get("errorFileRead"),ResourceManager.get("error"),JOptionPane.WARNING_MESSAGE);
						    return;
						}
						nomFichier=file.getPath();
					 }
				}
				if (nomFichier!=null){
				    nomFichier=nomFichier.replace('\\','/');				
				    nomFichier1.setText(nomFichier);
				}
			
			}

		}
	}
}
