package kartoMNT.visu3d;

import java.awt.*;
import java.io.*;
import java.util.*;

/**
 * KartoMNT V2 <BR>
 *	Mthode de chargement et sauvegarde des variables dans un fichier <BR>
 *  <BR>
 * Ralis sous la direction de LINGRAND Diane et FERNANDES Gilbert <BR>
 * Ecole Suprieure en Sciences Informatiques de Sophia-Antipolis (FRANCE)
 * </P>
 * @author DERHI Roland
 **/

public class Variables{
	// chargement des variables ds le chargement de la classe
    static{
		charge();	
    }
	/** Properties permettant l'enregistrement et la sauvegarde de variables */
    private static Properties applicationProps;


	/**
	 *	Mthode de chargement des variables
	 **/
    static void charge(){
	// create and load default properties
	
	try{
	    applicationProps = new Properties();
	    try{
		    FileInputStream in = new FileInputStream("Donnee.ini");
		    applicationProps.load(in);
	   		 in.close();
		}
		catch (FileNotFoundException ioe){
		    System.err.println("Fichier Donnee.ini introuvable !");
		}


	    String val=null;
		// chargement de la variable gridScaleX
	    val = applicationProps.getProperty("gridScaleX");
	    if (val!=null)
			gridScaleX = Float.parseFloat(val);	   
	    else{
			gridScaleX = 1;
			applicationProps.setProperty("gridScaleX","1");	
		}
		// chargement de la variable gridScaleY
	    val = applicationProps.getProperty("gridScaleY");
	    if (val!=null)
			gridScaleY = Float.parseFloat(val);	   
	    else{
			gridScaleY = 1;
			applicationProps.setProperty("gridScaleY","1");	
		}
		// chargement de la variable zScale
	    val = applicationProps.getProperty("zScale");
	    if (val!=null)
			zScale = Float.parseFloat(val);	   
	    else{
			zScale = 1;
			applicationProps.setProperty("zScale","1");
		}
		// chargement de la variable zClip
		val = applicationProps.getProperty("zClip");
	    if (val!=null)
		zClip = Float.parseFloat(val);	   
	    else{
			zClip = 10000;
			applicationProps.setProperty("zClip","10000");
		}

		
		// chargement de la variable mntURL
		val = applicationProps.getProperty("mntURL");
	    if (val!=null)
			mntURL = new String(val);	   
	    else{
			mntURL = "";
			applicationProps.setProperty("mntURL","");
		}

		// chargement de la variable textureURL
	    val = applicationProps.getProperty("textureURL");
	    if (val!=null)
			textureURL = new String(val);	   
	    else{
			textureURL = "";
			applicationProps.setProperty("textureURL","");
		}

	    
		val = applicationProps.getProperty("textureCalibreeURL");
	    if (val!=null)
			 textureCalibreeURL = new String(val);	   
	    else{
			textureCalibreeURL = "";
			applicationProps.setProperty("textureCalibreeURL","");
		}
	    // chargement de la variable backgroundURL
	    val = applicationProps.getProperty("backgroundURL");
	    if (val!=null)
		backgroundURL = new String(val);
	    else{
			backgroundURL = "";
			applicationProps.setProperty("backgroundURL","");	
		}
		// chargement de la variable LODDepth
	    val = applicationProps.getProperty("LODDepth");
	    if (val!=null)
		LODDepth = Integer.parseInt(val);
	    else{
			LODDepth = 1;
			applicationProps.setProperty("LODDepth","1");
		}
		// chargement de la variable LODLevel
	    val = applicationProps.getProperty("LODLevel");
	    if (val!=null)
		LODLevel = Integer.parseInt(val);
	    else{
			LODLevel = 1;
			applicationProps.setProperty("LODLevel","1");
		 }
		 
		 // chargement de la variable mntCourant
		 val = applicationProps.getProperty("mntCourant");		 
	    if (val!=null){
		mntCourant = (new Boolean(val)).booleanValue();
		}
	    else{
			mntCourant = true;
			applicationProps.setProperty("mntCourant","true");
		 }
		 // chargement de la variable texture
		 val = applicationProps.getProperty("texture");
	    if (val!=null){
		texture = Integer.parseInt(val);
		}
	    else{
			texture = 3;
			applicationProps.setProperty("texture","3");
		 }
		 // chargement de la variable background
		 val = applicationProps.getProperty("background");
	    if (val!=null){
		background = (new Boolean(val)).booleanValue();
		}
	    else{
			background = true;
			applicationProps.setProperty("background","true");
		 }
		 // chargement de la variable paramAuto
		 val = applicationProps.getProperty("paramAuto");
	    if (val!=null){
		paramAuto = (new Boolean(val)).booleanValue();
		}
	    else{
			paramAuto = true;
			applicationProps.setProperty("paramAuto","true");
		 }
		// chargement de la variable quality1
		val = applicationProps.getProperty("quality1");
	    if (val!=null){
		quality1 = Float.parseFloat(val);;
		}
	    else{
			quality1 = 100.0f;
			applicationProps.setProperty("quality1","100.0");
		 }
		 // chargement de la variable quality2
		 val = applicationProps.getProperty("quality2");
	    if (val!=null){
		quality2 = Float.parseFloat(val);;
		}
	    else{
			quality2 = 200.0f;
			applicationProps.setProperty("quality2","200.0");
		 }
		 // chargement de la variable quality3
		 val = applicationProps.getProperty("quality3");
	    if (val!=null){
		quality3 = Float.parseFloat(val);;
		}
	    else{
			quality3 = 300.0f;
			applicationProps.setProperty("quality3","300.0");
		 }
		 // chargement de la variable quality4
		 val = applicationProps.getProperty("quality4");
	    if (val!=null){
		quality4 = Float.parseFloat(val);;
		}
	    else{
			quality4 = 400.0f;
			applicationProps.setProperty("quality4","400.0");
		 }
		 // chargement de la variable quality5
		 val = applicationProps.getProperty("quality5");
	    if (val!=null){
		quality5 = Float.parseFloat(val);;
		}
	    else{
			quality5 = 500.0f;
			applicationProps.setProperty("quality5","500.0");
		 }
		 // chargement de la variable quality6
		 val = applicationProps.getProperty("quality6");
	    if (val!=null){
		quality6 = Float.parseFloat(val);;
		}
	    else{
			quality6 = 750.0f;
			applicationProps.setProperty("quality6","750.0");
		 }
		 // chargement de la variable quality7
		 val = applicationProps.getProperty("quality7");
	    if (val!=null){
		quality7 = Float.parseFloat(val);;
		}
	    else{
			quality7 = 1000.0f;
			applicationProps.setProperty("quality7","1000.0");
		 }
		 // chargement de la variable quality8
		 val = applicationProps.getProperty("quality8");
	    if (val!=null){
		quality8 = Float.parseFloat(val);;
		}
	    else{
			quality8 = 2000.0f;
			applicationProps.setProperty("quality8","2000.0");
		 }
		// chargement de la variable quality9
		val = applicationProps.getProperty("quality9");
	    if (val!=null){
		quality9 = Float.parseFloat(val);;
		}
	    else{
			quality9 = 5000.0f;
			applicationProps.setProperty("quality9","5000.0");
		 }

		// chargement de la variable quality10
		val = applicationProps.getProperty("quality10");
	    if (val!=null){
		quality10 = Float.parseFloat(val);;
		}
	    else{
			quality10 = 10000.0f;
			applicationProps.setProperty("quality10","10000.0");
		 }
		 
		 // chargement de la variable texture
		 val = applicationProps.getProperty("qualCaptW");
	    if (val!=null){
		qualCaptW = Integer.parseInt(val);
		}
	    else{
			qualCaptW = 1600;
			applicationProps.setProperty("qualCaptW","1600");
		 }
		 
		 // chargement de la variable texture
		 val = applicationProps.getProperty("qualCaptH");
	    if (val!=null){
		qualCaptH = Integer.parseInt(val);
		}
	    else{
			qualCaptH = 1600;
			applicationProps.setProperty("qualCaptH","1600");
		 }
		 
		 


	    // chargement de la variable boucheTrouCouleur
	    val = applicationProps.getProperty("boucheTrouCouleur");
	    if (val!=null){
		boucheTrouCouleur = Color.decode(val);
	    }
	    else{
		boucheTrouCouleur = Color.WHITE;
		applicationProps.setProperty("boucheTrouCouleur",Integer.toString(boucheTrouCouleur.getRGB()));
	    }


	    // chargement de la variable boucheTrouTexture
	    val = applicationProps.getProperty("boucheTrouTexture");
	    if (val!=null)
		boucheTrouTexture = new String(val);
	    else{
		boucheTrouTexture = "";
		applicationProps.setProperty("boucheTrouTexture","");	
	    }

	    // chargement de la variable bTCS
	    val = applicationProps.getProperty("bTCS");
	    if (val!=null){
		bTCS = (new Boolean(val)).booleanValue();
	    }
	    else{
		bTCS = true;
		applicationProps.setProperty("bTCS","true");
	    }
	    
	}
	catch (IOException ioe){
	    System.err.println("Problme lors du chargement de Donnee.ini !");
	}

    }

	/**
	 *	Mthode de sauvegarde des variables
	 **/
    static void sauve(){
		try{
		    FileOutputStream out = new FileOutputStream("Donnee.ini");
		    applicationProps.store(out, "---Donnees ---");
		    out.close();
		}	
		catch (IOException ioe){
		    System.err.println("Problme lors de la sauvegarde de Donnee.ini !");
		}
    }
    
    /**
     *	Sauvegarde et chargement de la variable
     * @param key le nom de la variable
     * @param value sa valeur
     **/
    public static void setVariable(String key,String value){
    	applicationProps.setProperty(key,value);
	    sauve();
	    charge();	    
	 }


	/** Scaling of grids X */
    public static float gridScaleX;
	/** Scaling of grids Y */
    public static float gridScaleY;
    /** Scaling of height */
	public static float zScale;
	/** Clipping en Z */
	public static float zClip;
	/** URL du MNT  utiliser */
	public static String mntURL;
	/** URL de la texture  utiliser */
	public static String textureURL;
    /** URL de la texture calibre  utiliser  */
    public static String textureCalibreeURL;
	/** URL de l'image de fond */
	public static String backgroundURL;
	/** Number is LOD models */
	public static int LODDepth;
	/** LOD subdivision level */
	public static int LODLevel;
	
	/** doit-on choisir le mnt courant ? */
	public static boolean mntCourant;
	/** quel type de texturage doit-on choisir pour le mnt ? */
	public static int texture;
	/** doit-on ajouter un background ? */
	public static boolean background;
	/** doit-on choisir les parametres automatiquement ? */
	public static boolean paramAuto;

	/** qualit 1 de MNT */
	public static float quality1;
	/** qualit 2 de MNT */
	public static float quality2;
	/** qualit 3 de MNT */
	public static float quality3;
	/** qualit 4 de MNT */
	public static float quality4;
	/** qualit 5 de MNT */
	public static float quality5;
	/** qualit 6 de MNT */
	public static float quality6;
	/** qualit 7 de MNT */
	public static float quality7;
	/** qualit 8 de MNT */
	public static float quality8;
	/** qualit 9 de MNT */
	public static float quality9;
	/** qualit 10 de MNT */
	public static float quality10;
	
	/** Largeur de la capture d'cran haute qualit */
	public static int qualCaptW;
	/** Hauteur de la capture d'cran haute qualit */
	public static int qualCaptH;
    
    /** Couleur Bouche Trou */
    public static Color boucheTrouCouleur;
    /** Texture bouche Trou */
    public static String boucheTrouTexture;
    /** Est-ce la couleur bouche trou qui a t choisie */
    public static boolean bTCS;
    
}
